/*  Borland C demo                                  */
/*                                                  */
/*  Please see Visual C samples for more details    */
/*  and Visual C++ programs                         */
/*                                                  */


#include <stdio.h>
#include <windows.h>
#include <conio.h>
#include <memory.h>

#include "..\..\MS Visual C\medefines.h"
#include "..\..\MS Visual C\DLLInit.h"           // for using with dynamic DLL accessing

#ifdef __BORLANDC__
#include <condefs.h>
USEFILE("..\..\MS Visual C\medefines.h");
USEFILE("..\..\MS Visual C\DLLInit.h");
USEUNIT("..\..\MS Visual C\DLLInit.cpp");
#endif

#include <TestConsoleGeneric.c>


int main(int argc, char* argv[])
{
    meOpenDynamicAccess();
        
	// Call generic console function in parent directory to 
	// open system and list the available devices and subdevices.

	int i_number_of_devices = TestConsoleMEIDSProlog();

	if(i_number_of_devices <= 0)
	{
		return(-1);
	}

	// ---------------------------------------------------------------------
	
	// Count the DO and DIO sub-devices in the system

	int i_number_ctr_8254_subdevices = 0;

	int i_me_error;

	for(int index_device = 0; index_device < i_number_of_devices; index_device++)
	{
		int i_vendor_id;
		int i_device_id;
		int i_serial_no;
		int i_bus_type;
		int i_bus_no;
		int i_dev_no;
		int i_func_no;
		int i_plugged;
		
		i_me_error = meQueryInfoDevice(	index_device,				// Device index
										&i_vendor_id,				// Vendor ID returned here - not required				
										&i_device_id,				// Device ID returned here - not required
										&i_serial_no,				// Serial number returned here - not required
										&i_bus_type,				// Bus type returned here - not required
										&i_bus_no,					// Bus number returned here - not required
										&i_dev_no,					// Bus device number returned here - not required
										&i_func_no,					// Bus function number returned here - not required
										&i_plugged				);	// Plugged status returned hee - not required

		if(i_plugged != ME_PLUGGED_IN)
		{
			continue;
		}

		int index_subdevice = 0;

		int i_number_of_subdevices;

		i_me_error = meQueryNumberSubdevices(	index_device,				// Device index
												&i_number_of_subdevices);	// Number of subdevices returned here
		
		while(true)
		{
			i_me_error = meQuerySubdeviceByType(index_device,					// Device
												index_subdevice,				// Begin search at this sub-device 
												ME_TYPE_CTR,					// Type of sub-device to search for
												ME_SUBTYPE_CTR_8254,			// Sub-type of sub-device to search for
												&index_subdevice	);			// sub-device index returned here

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				break;
			}
			
			++i_number_ctr_8254_subdevices;

			if(++index_subdevice >= i_number_of_subdevices)
			{
				break;
			}
		}
	}

	if(i_number_ctr_8254_subdevices == 0)
	{
		printf("****    No 8254 counter sub-devices found in system    ****\n\n");
		
		printf("Press any key to terminate\n");
		
		_getch();
		
		meClose(0);
		
		return -1;
	}

	// Make a list of the 8254 counter sub-devices

	struct SCounter8254Subddevice
	{
		int	m_iDeviceIndex;

		int m_iSubdeviceIndex;

		int m_iNumberOfClockSources;

		int m_arrClockSources[4];
	};

	SCounter8254Subddevice* arrSubdevices = new SCounter8254Subddevice[i_number_ctr_8254_subdevices];

	i_number_ctr_8254_subdevices = 0;

	for(int index_device = 0; index_device < i_number_of_devices; index_device++)
	{
		int i_vendor_id;
		int i_device_id;
		int i_serial_no;
		int i_bus_type;
		int i_bus_no;
		int i_dev_no;
		int i_func_no;
		int i_plugged;
		
		i_me_error = meQueryInfoDevice(	index_device,				// Device index
										&i_vendor_id,				// Vendor ID returned here - not required				
										&i_device_id,				// Device ID returned here - not required
										&i_serial_no,				// Serial number returned here - not required
										&i_bus_type,				// Bus type returned here - not required
										&i_bus_no,					// Bus number returned here - not required
										&i_dev_no,					// Bus device number returned here - not required
										&i_func_no,					// Bus function number returned here - not required
										&i_plugged				);	// Plugged status returned hee - not required

		if(i_plugged != ME_PLUGGED_IN)
		{
			continue;
		}

		int index_subdevice = 0;
		
		int i_number_of_subdevices;

		i_me_error = meQueryNumberSubdevices(	index_device,				// Device index
												&i_number_of_subdevices);	// Number of subdevices returned here
		
		while(true)
		{
			i_me_error = meQuerySubdeviceByType(index_device,					// Device
												index_subdevice,				// Begin search at this sub-device 
												ME_TYPE_CTR,					// Type of sub-device to search for
												ME_SUBTYPE_CTR_8254,			// Sub-type of sub-device to search for
												&index_subdevice	);			// sub-device index returned here

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				break;
			}

			arrSubdevices[i_number_ctr_8254_subdevices].m_iDeviceIndex = index_device;

			arrSubdevices[i_number_ctr_8254_subdevices].m_iSubdeviceIndex = index_subdevice;

			int i_caps = 0;
			
			i_me_error = meQuerySubdeviceCaps(	index_device,			// Device
												index_subdevice,		// Sub-device 
												&i_caps				);	// Number of channels returned here


			arrSubdevices[i_number_ctr_8254_subdevices].m_iNumberOfClockSources = 0;

			if( (i_caps & ME_CAPS_CTR_CLK_PREVIOUS) ==  ME_CAPS_CTR_CLK_PREVIOUS )
			{
				arrSubdevices[i_number_ctr_8254_subdevices].m_arrClockSources[ arrSubdevices[i_number_ctr_8254_subdevices].m_iNumberOfClockSources ] = ME_CAPS_CTR_CLK_PREVIOUS;

				++arrSubdevices[i_number_ctr_8254_subdevices].m_iNumberOfClockSources;
			}
			
			if( (i_caps & ME_CAPS_CTR_CLK_INTERNAL_1MHZ) ==  ME_CAPS_CTR_CLK_INTERNAL_1MHZ )
			{
				arrSubdevices[i_number_ctr_8254_subdevices].m_arrClockSources[ arrSubdevices[i_number_ctr_8254_subdevices].m_iNumberOfClockSources ] = ME_CAPS_CTR_CLK_INTERNAL_1MHZ;

				++arrSubdevices[i_number_ctr_8254_subdevices].m_iNumberOfClockSources;
			}
			
			if( (i_caps & ME_CAPS_CTR_CLK_INTERNAL_10MHZ) ==  ME_CAPS_CTR_CLK_INTERNAL_10MHZ )
			{
				arrSubdevices[i_number_ctr_8254_subdevices].m_arrClockSources[ arrSubdevices[i_number_ctr_8254_subdevices].m_iNumberOfClockSources ] = ME_CAPS_CTR_CLK_INTERNAL_10MHZ;

				++arrSubdevices[i_number_ctr_8254_subdevices].m_iNumberOfClockSources;
			}
			
			if( (i_caps & ME_CAPS_CTR_CLK_EXTERNAL) ==  ME_CAPS_CTR_CLK_EXTERNAL )
			{
				arrSubdevices[i_number_ctr_8254_subdevices].m_arrClockSources[ arrSubdevices[i_number_ctr_8254_subdevices].m_iNumberOfClockSources ] = ME_CAPS_CTR_CLK_EXTERNAL;

				++arrSubdevices[i_number_ctr_8254_subdevices].m_iNumberOfClockSources;
			}
			
			++i_number_ctr_8254_subdevices;
			
			if(++index_subdevice >= i_number_of_subdevices)
			{
				break;
			}
		}
	}

	printf("%d 8254 counter sub-devices found:\n\n", i_number_ctr_8254_subdevices);

	for(int index_subdevice = 0; index_subdevice < i_number_ctr_8254_subdevices; index_subdevice++)
	{
		printf("%2d.   Device: %2d  Sub-device: %2d Supports ",
				index_subdevice + 1,
				arrSubdevices[index_subdevice].m_iDeviceIndex,
				arrSubdevices[index_subdevice].m_iSubdeviceIndex					);

		for(int index_clock_type = 0; index_clock_type < arrSubdevices[index_subdevice].m_iNumberOfClockSources; index_clock_type++)
		{
			if(arrSubdevices[index_subdevice].m_arrClockSources[index_clock_type] == ME_CAPS_CTR_CLK_PREVIOUS)
			{
				printf("Previous");
			}
			else if(arrSubdevices[index_subdevice].m_arrClockSources[index_clock_type] == ME_CAPS_CTR_CLK_INTERNAL_1MHZ)
			{
				printf("Internal 1 MHz");
			}
			else if(arrSubdevices[index_subdevice].m_arrClockSources[index_clock_type] == ME_CAPS_CTR_CLK_INTERNAL_10MHZ)
			{
				printf("Internal 10 MHz");
			}
			else if(arrSubdevices[index_subdevice].m_arrClockSources[index_clock_type] == ME_CAPS_CTR_CLK_EXTERNAL)
			{
				printf("External");
			}

			if(index_clock_type < arrSubdevices[index_subdevice].m_iNumberOfClockSources - 1)
			{
				printf(", ");
			}
			else
			{
				printf(" clock input\n");
			}
		}
	}


	printf("\n\nPress any key to continue\n\n");

	getch();

	char buffer[512];
	
	while(true)
	{
		int index_subdevice;

		int i_number_function;

		bool b_terminate = false;

		while(true)
		{
			printf("Choose sub-device:\n\n");

			for(index_subdevice = 0; index_subdevice < i_number_ctr_8254_subdevices; index_subdevice++)
			{
				printf("%2d.   Device: %2d  Sub-device: %2d Supports ",
						index_subdevice + 1,
						arrSubdevices[index_subdevice].m_iDeviceIndex,
						arrSubdevices[index_subdevice].m_iSubdeviceIndex					);

				for(int index_clock_src = 0; index_clock_src < arrSubdevices[index_subdevice].m_iNumberOfClockSources; index_clock_src++)
				{
					if(arrSubdevices[index_subdevice].m_arrClockSources[index_clock_src] == ME_CAPS_CTR_CLK_PREVIOUS)
					{
						printf("Previous");
					}
					else if(arrSubdevices[index_subdevice].m_arrClockSources[index_clock_src] == ME_CAPS_CTR_CLK_INTERNAL_1MHZ)
					{
						printf("Internal 1 MHz");
					}
					else if(arrSubdevices[index_subdevice].m_arrClockSources[index_clock_src] == ME_CAPS_CTR_CLK_INTERNAL_10MHZ)
					{
						printf("Internal 10 MHz");
					}
					else if(arrSubdevices[index_subdevice].m_arrClockSources[index_clock_src] == ME_CAPS_CTR_CLK_EXTERNAL)
					{
						printf("External");
					}

					if(index_clock_src < arrSubdevices[index_subdevice].m_iNumberOfClockSources - 1)
					{
						printf(", ");
					}
					else
					{
						printf(" clock input\n");
					}
				}
			}

			printf("\nYour choice (1 - %2d) (RETURN to terminate): ", i_number_ctr_8254_subdevices);  

			gets(&buffer[0]);

			printf("\n\n");
			
			if(buffer[0] == 0)
			{
				b_terminate = true;
				
				break;
			}
			
			if( (sscanf(&buffer[0], "%d", &index_subdevice) != 1 ) )
			{
				continue;
			}

			if( (index_subdevice < 1)||(index_subdevice > i_number_ctr_8254_subdevices) )
			{
				continue;
			}

			--index_subdevice;

			break;
		}

		if(b_terminate)
		{
			break;
		}
			
		while(true)
		{
			printf("Choose function:\n\n");

			printf(	"1. Reset\n"
					"2. Config\n"
					"3. Write\n"
					"4. Read\n\n");


			printf("\nYour choice (1 - 4) (RETURN to terminate): ");  

			gets(&buffer[0]);

			printf("\n\n");
			
			if(buffer[0] == 0)
			{
				b_terminate = true;
				
				break;
			}
			
			if( (sscanf(&buffer[0], "%d", &i_number_function) != 1 ) )
			{
				continue;
			}

			if( (i_number_function < 1)||(i_number_function > 4) )
			{
				continue;
			}

			break;
		}

		if(b_terminate)
		{
			break;
		}

		int b_cancel = false;

		switch(i_number_function)
		{
		case 1:	// Reset

			printf("Press any key to reset Device: %d Subdevice: %d\n\n", arrSubdevices[index_subdevice].m_iDeviceIndex, arrSubdevices[index_subdevice].m_iSubdeviceIndex);

			getch();

			i_me_error = meIOResetSubdevice(arrSubdevices[index_subdevice].m_iDeviceIndex,		// Device index
											arrSubdevices[index_subdevice].m_iSubdeviceIndex,	// Subdevice index
											ME_IO_RESET_SUBDEVICE_NO_FLAGS					);	// Flags

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				printf("****    meIOResetSubdevice - Error: %d    ****\n\n", i_me_error);

				printf("Press any key to terminate\n");
				
				_getch();
				
				meClose(0);
				
				return -1;
			}

			printf("Device: %d Subdevice: %d reset, press any key to continue\n\n", arrSubdevices[index_subdevice].m_iDeviceIndex, arrSubdevices[index_subdevice].m_iSubdeviceIndex);

			_getch();

			break;

		case 2: // Config

			int i_mode;
			
			while(true)
			{
				printf("Choose mode (0 - 5) (RETURN to cancel): ");  

				gets(&buffer[0]);

				printf("\n\n");
				
				if(buffer[0] == 0)
				{
					b_cancel = true;
					
					break;
				}
				
				if( (sscanf(&buffer[0], "%d", &i_mode) != 1 ) )
				{
					continue;
				}

				if( (i_mode < 0)||(i_mode > 5 ) )
				{
					continue;
				}

				break;
			}

			if(b_cancel)
			{
				break;
			}

			int index_src;
			
			if(arrSubdevices[index_subdevice].m_iNumberOfClockSources  > 1)
			{
				while(true)
				{
					printf("Choose clock source:\n\n");

					for(index_src = 0; index_src < arrSubdevices[index_subdevice].m_iNumberOfClockSources; index_src++)
					{
						printf("    %2d.   ", index_src + 1);

						if(arrSubdevices[index_subdevice].m_arrClockSources[index_src] == ME_CAPS_CTR_CLK_PREVIOUS)
						{
							printf("Previous\n");
						}
						else if(arrSubdevices[index_subdevice].m_arrClockSources[index_src] == ME_CAPS_CTR_CLK_INTERNAL_1MHZ)
						{
							printf("Internal 1 MHz\n");
						}
						else if(arrSubdevices[index_subdevice].m_arrClockSources[index_src] == ME_CAPS_CTR_CLK_INTERNAL_10MHZ)
						{
							printf("Internal 10 MHz\n");
						}
						else if(arrSubdevices[index_subdevice].m_arrClockSources[index_src] == ME_CAPS_CTR_CLK_EXTERNAL)
						{
							printf("External\n");
						}
					}

					printf("\nYour choice (1 - %2d) (RETURN to cancel): ", arrSubdevices[index_subdevice].m_iNumberOfClockSources);  

					gets(&buffer[0]);

					printf("\n\n");
					
					if(buffer[0] == 0)
					{
						b_cancel = true;
						
						break;
					}
					
					if( (sscanf(&buffer[0], "%d", &index_src) != 1 ) )
					{
						continue;
					}

					if( (index_src < 1)||(index_src > arrSubdevices[index_subdevice].m_iNumberOfClockSources) )
					{
						continue;
					}

					break;
				}

				if(b_cancel)
				{
					break;
				}

				--index_src;
			}
			else
			{
				index_src = 0;
			}

			if(b_cancel)
			{
				break;
			}

			int i_ref;
			
			switch(arrSubdevices[index_subdevice].m_arrClockSources[index_src])
			{
			case ME_CAPS_CTR_CLK_PREVIOUS:

				i_ref = ME_REF_CTR_PREVIOUS;

				break;

			case ME_CAPS_CTR_CLK_INTERNAL_1MHZ:

				i_ref = ME_REF_CTR_INTERNAL_1MHZ;

				break;

			case ME_CAPS_CTR_CLK_INTERNAL_10MHZ:

				i_ref = ME_REF_CTR_INTERNAL_10MHZ;

				break;

			case ME_CAPS_CTR_CLK_EXTERNAL:

				i_ref = ME_REF_CTR_EXTERNAL;

				break;
			}

			int i_single_config;

			switch(i_mode)
			{
			case 0:

				i_single_config = ME_SINGLE_CONFIG_CTR_8254_MODE_0;

				break;

			case 1:

				i_single_config = ME_SINGLE_CONFIG_CTR_8254_MODE_1;

				break;

			case 2:

				i_single_config = ME_SINGLE_CONFIG_CTR_8254_MODE_2;

				break;

			case 3:

				i_single_config = ME_SINGLE_CONFIG_CTR_8254_MODE_3;

				break;

			case 4:

				i_single_config = ME_SINGLE_CONFIG_CTR_8254_MODE_4;

				break;

			case 5:

				i_single_config = ME_SINGLE_CONFIG_CTR_8254_MODE_5;

				break;
			}

			i_me_error = meIOSingleConfig(	arrSubdevices[index_subdevice].m_iDeviceIndex,		// Device index
											arrSubdevices[index_subdevice].m_iSubdeviceIndex,	// Subdevcie index
											0,													// Channel
											i_single_config,									// Single config
											i_ref,												// Reference 
											ME_TRIG_CHAN_DEFAULT,								// Trigger channel
											ME_TRIG_TYPE_NONE,									// Trigger type
											ME_VALUE_NOT_USED,									// Trigger edge
											ME_IO_SINGLE_CONFIG_NO_FLAGS					);	// Flags

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				printf("****    meIOSingleConfig - Error: %d    ****\n\n", i_me_error);

				printf("Press any key to terminate\n");
				
				_getch();
				
				meClose(0);
				
				return -1;
			}

			printf("Device: %d Subdevice: %d has been configured - press any key to continue\n\n", arrSubdevices[index_subdevice].m_iDeviceIndex, arrSubdevices[index_subdevice].m_iSubdeviceIndex);

			getch();
			
			break;

		case 3: // Write

			int i_value;

			while(true)
			{
				printf("Value to output (RETURN to cancel): ");  

				gets(&buffer[0]);

				printf("\n\n");
				
				if(buffer[0] == 0)
				{
					b_cancel = true;
					
					break;
				}
				
				if( (sscanf(&buffer[0], "%X", &i_value) != 1 ) )
				{
					continue;
				}

				break;
			}

			if(b_cancel)
			{
				break;
			}

			meIOSingle_t io_single[1];

			io_single[0].iDevice = arrSubdevices[index_subdevice].m_iDeviceIndex;

			io_single[0].iSubdevice = arrSubdevices[index_subdevice].m_iSubdeviceIndex;
			io_single[0].iChannel	= 0;
			io_single[0].iDir		= ME_DIR_OUTPUT;
			io_single[0].iValue		= i_value;
			io_single[0].iTimeOut	= 0;							// No timeout - not required for software output
			io_single[0].iFlags		= ME_IO_SINGLE_TYPE_NO_FLAGS;
			
			i_me_error = meIOSingle(&io_single[0],				// Output list 
									1,							// Number of elements in the above list 
									ME_IO_SINGLE_NO_FLAGS	);	// Flags

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				printf("****    meIOSingle - Error: %d    ****\n\n", i_me_error);

				printf("Press any key to terminate\n");
				
				_getch();
				
				meClose(0);
				
				return -1;
			}

			printf("%d output to Device: %d Subdevice: %d - press any key to continue\n\n", i_value, arrSubdevices[index_subdevice].m_iDeviceIndex, arrSubdevices[index_subdevice].m_iSubdeviceIndex);

			getch();
			
			break;

		case 4: // Read

			printf("Press any key to read from Device: %d Subdevice: %d\n\n", arrSubdevices[index_subdevice].m_iDeviceIndex, arrSubdevices[index_subdevice].m_iSubdeviceIndex);

			getch();

			io_single[0].iDevice = arrSubdevices[index_subdevice].m_iDeviceIndex;

			io_single[0].iSubdevice = arrSubdevices[index_subdevice].m_iSubdeviceIndex;
			io_single[0].iChannel	= 0;
			io_single[0].iDir		= ME_DIR_INPUT;
			io_single[0].iValue		= 0;
			io_single[0].iTimeOut	= 0;							// No timeout - not required for software output
			io_single[0].iFlags		= ME_IO_SINGLE_TYPE_NO_FLAGS;
			
			i_me_error = meIOSingle(&io_single[0],				// Output list 
									1,							// Number of elements in the above list 
									ME_IO_SINGLE_NO_FLAGS	);	// Flags

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				printf("****    meIOSingle - Error: %d    ****\n\n", i_me_error);

				printf("Press any key to terminate\n");
				
				_getch();
				
				meClose(0);
				
				return -1;
			}

			printf("Read %d ftom Device: %d Subdevice: %d, press any key to continue\n\n", io_single[0].iValue, arrSubdevices[index_subdevice].m_iDeviceIndex, arrSubdevices[index_subdevice].m_iSubdeviceIndex);

			_getch();

			break;
		}
	}

	delete []arrSubdevices;

	// ---------------------------------------------------------------------
	
	meClose(0);
	meCloseDynamicAccess();
	
	printf("Program completed successfully - Press any key to terminate\n\n");

	_getch();
	
	return 0;
}
