//==============================================================================
//Copyright(c), Meilhaus Electronic GmbH
//              http://www.meilhaus.de
//              support@meilhaus.de
//
//Source File : uAbout.pas
//Description : Info-about window
//            : 2011-02-24
//==============================================================================
unit uAbout;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TfrmAbout = class(TForm)
    btnOk: TButton;
    memoAbout: TMemo;
    img1: TImage;
    lbl1: TLabel;
    lbl2: TLabel;
    lbl3: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
    function GetVersion(fName: string): string;
  public
    { Public-Deklarationen }
  end;

var
  frmAbout: TfrmAbout;

implementation

{$R *.dfm}

procedure TfrmAbout.FormCreate(Sender: TObject);
begin
  lbl1.Caption := Application.Title;
  lbl2.Caption := 'Version: ' + GetVersion(Paramstr(0));

  memoAbout.Clear;
  memoAbout.Lines.Append(Application.Title);
  memoAbout.Lines.Append('written in Delphi');
  memoAbout.Lines.Append('');
  memoAbout.Lines.Append('Meilhaus Electronic GmbH');
  memoAbout.Lines.Append('Am Sonnenlicht 2');
  memoAbout.Lines.Append('D-82239 Alling/Munich');
  memoAbout.Lines.Append('Germany');
  memoAbout.Lines.Append('');
  memoAbout.Lines.Append('http://www.meilhaus.com');
  memoAbout.Lines.Append('E-Mail: support@meilhaus.com');
end;

function TfrmAbout.GetVersion(fName: string): string;
var
  VerInfoSize: DWORD;
  VerInfo: Pointer;
  VerValueSize: DWORD;
  VerValue: PVSFixedFileInfo;
  Dummy: DWORD;
begin
  Result := '';
  VerInfoSize := GetFileVersionInfoSize(PChar(fName), Dummy);
  if VerInfoSize = 0 then Exit;
  GetMem(VerInfo, VerInfoSize);
  try
    GetFileVersionInfo(PChar(fName), 0, VerInfoSize, VerInfo);
    VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
    with VerValue^ do
    begin
      Result := Format('%d.%d.%d.%d', [dwFileVersionMS shr 16, dwFileVersionMS and $FFFF, dwFileVersionLS shr 16, dwFileVersionLS and $FFFF]);
    end;
  finally
    FreeMem(VerInfo, VerInfoSize);
  end;
end;

end.
