Option Strict Off
Option Explicit On

Imports System.Threading

Imports System.Text

Friend Class frmMain
    Inherits System.Windows.Forms.Form

    Dim giDeviceNumber As Integer

    Dim giSubdeviceNumber As Integer

    Dim gdADCFrequency As Double

    Dim gdWindowWidth As Double

    Dim gdCurrentXPix As Double

    Dim gdXPixIncrement As Double

    Dim gdYPixelFactor As Double

    Dim giLastXPixel As Integer

    Dim giLastYPixel(3) As Integer

    Dim glPlotColor(3) As Color

    Dim gbDrawPlot As Boolean

    Dim giBuffer(999) As Integer

    'Dim gTimer As New System.Timers.Timer()

    Dim gTimerDelegate As TimerCallback

    Dim gTimer As Timer

    Dim giDigitalMax As Integer



    Public Sub PlotData(ByRef piData() As Integer, ByVal lNumberOfData As Integer)

        Dim i_no_frames As Integer

        Dim d_current_pix As Double

        Dim i_old_x_pix As Single

        Dim i_channel As Integer

        Dim i_frame As Integer

        Dim i_X_pix As Integer

        Dim i_Y_pix As Integer

        Dim i_erase_from_pixel As Integer

        Dim i_erase_to_pixel As Integer

        Dim str_mess As New StringBuilder

        str_mess.AppendFormat("PlotData Called - lNumberOfData: {0}", lNumberOfData)

        Debug.WriteLine(str_mess)

        If Not gbDrawPlot Then
            Exit Sub
        End If

        i_no_frames = lNumberOfData / 4

        If i_no_frames < 1 Then
            Exit Sub
        End If

        Dim g As Graphics = PlotArea.CreateGraphics()

        Dim SBrush As New System.Drawing.SolidBrush(System.Drawing.Color.Black)

        i_erase_from_pixel = giLastXPixel + 1

        i_erase_to_pixel = CInt(gdCurrentXPix + CDbl(i_no_frames) * gdXPixIncrement)

        If i_erase_to_pixel > i_erase_from_pixel Then

            If i_erase_to_pixel > Me.PlotArea.ClientRectangle.Width Then

                ' Erase right hand side of plot

                g.DrawRectangle(Pens.Black, i_erase_from_pixel, 0, Me.PlotArea.ClientRectangle.Width, Me.PlotArea.ClientRectangle.Height)
                g.FillRectangle(SBrush, i_erase_from_pixel, 0, Me.PlotArea.ClientRectangle.Width, Me.PlotArea.ClientRectangle.Height)

                i_erase_from_pixel = 0
                i_erase_to_pixel = i_erase_to_pixel - PlotArea.ClientRectangle.Width

            End If

            g.DrawRectangle(Pens.Black, i_erase_from_pixel, 0, i_erase_to_pixel + 1, Me.PlotArea.ClientRectangle.Height)
            g.FillRectangle(SBrush, i_erase_from_pixel, 0, i_erase_to_pixel + 1, Me.PlotArea.ClientRectangle.Height)

        End If

        For i_channel = 0 To 3

            Dim SPen As New System.Drawing.Pen(glPlotColor(i_channel))

            i_old_x_pix = giLastXPixel

            d_current_pix = gdCurrentXPix

            For i_frame = 0 To i_no_frames - 1

                i_X_pix = CInt(d_current_pix)

                i_Y_pix = CInt(gdYPixelFactor * CInt(piData(i_channel + i_frame * 4))) + 10

                If Not gbDrawPlot Then
                    Exit Sub
                End If

                ' To save time we only draw a line if the position has changed

                If i_old_x_pix <> i_X_pix Or giLastYPixel(i_channel) <> i_Y_pix Then
                    If i_old_x_pix <> -1 Then
                        'UPGRADE_ISSUE: PictureBox method PlotArea.Line was not upgraded. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="CC4C7EC0-C903-48FC-ACCC-81861D12DA4A"'

                        g.DrawLine(SPen, i_old_x_pix, giLastYPixel(i_channel), i_X_pix, i_Y_pix)

                    End If

                    giLastYPixel(i_channel) = i_Y_pix

                    i_old_x_pix = i_X_pix
                End If

                d_current_pix = d_current_pix + gdXPixIncrement

                If CInt(d_current_pix) > PlotArea.ClientRectangle.Width Then
                    d_current_pix = d_current_pix - PlotArea.ClientRectangle.Width

                    i_old_x_pix = i_old_x_pix - PlotArea.ClientRectangle.Width
                End If

            Next i_frame

        Next i_channel

        gdCurrentXPix = d_current_pix

        giLastXPixel = i_old_x_pix

        Debug.WriteLine("Exit PlotData")

        g.DrawLine(Pens.White, giLastXPixel + 1, 0, giLastXPixel + 1, Me.PlotArea.ClientRectangle.Height)

        g.Dispose()

    End Sub

    Public Sub ReadData(ByVal stateInfo As Object)

        Dim arr_data(999) As Integer

        Dim i_count As Integer

        Debug.WriteLine("Enter ReadData")

        i_count = 1000

        meIOStreamRead(giDeviceNumber, _
                        giSubdeviceNumber, _
                        ME_READ_MODE_NONBLOCKING, _
                        arr_data(0), _
                        i_count, _
                        ME_IO_STREAM_READ_NO_FLAGS)

        If (i_count > 0) Then

            PlotData(arr_data, i_count)

        End If

    End Sub



    Private Sub cmdExit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdExit.Click

        Dim i_me_error As Integer

        i_me_error = meClose(0)

        Close()

    End Sub

    Private Sub cmdStart_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdStart.Click

        Dim i_me_error As Integer

        Dim b_channel(3) As Byte

        Dim i_acq_ticks_low As Integer
        Dim i_acq_ticks_high As Integer

        Dim d_time As Double

        Dim d_required_freq As Double
        Dim d_achieved_freq As Double

        Dim i_scan_ticks_low As Integer
        Dim i_scan_ticks_high As Integer

        Dim i_conv_ticks_low As Integer
        Dim i_conv_ticks_high As Integer

        Dim i_range As Integer

        Dim d_phys_min As Double

        Dim d_phys_max As Double

        ' Use the utility functions to convert the required timing parameters into 
        ' ticks which we can pass to the hardware in meIOStreamConfig below.

        ' For the acquisition ticks, the time that elapses between the trigger arriving 
        ' and the start of the acquisition, we require the minimum value.
        ' We call meIOStreamTimeToTicks with a time of zero and the function will return 
        ' the minimum tick value.

        i_acq_ticks_low = 0
        i_acq_ticks_high = 0

        d_time = 0.0

        i_me_error = meIOStreamTimeToTicks(giDeviceNumber, _
                                            giSubdeviceNumber, _
                                            ME_TIMER_ACQ_START, _
                                            d_time, _
                                            i_acq_ticks_low, _
                                            i_acq_ticks_high, _
                                            ME_IO_FREQUENCY_TO_TICKS_NO_FLAGS)

        If (i_me_error <> ME_ERRNO_SUCCESS) Then

            Exit Sub

        End If

        ' For the scan ticks, which determine the sum sampling rate, we pass 
        ' our required frequency to meIOStreamFrequencyToTicks. The necessary 
        ' tick values are returned by the function.

        ' The frequency actually obtained with these tick values is returned 
        ' in the same variable that we used to pass the desired frequency. 

        d_required_freq = gdADCFrequency
        d_achieved_freq = d_required_freq

        i_scan_ticks_low = 0
        i_scan_ticks_high = 0

        i_me_error = meIOStreamFrequencyToTicks(giDeviceNumber, _
                                                giSubdeviceNumber, _
                                                ME_TIMER_SCAN_START, _
                                                d_achieved_freq, _
                                                i_scan_ticks_low, _
                                                i_scan_ticks_high, _
                                                ME_IO_FREQUENCY_TO_TICKS_NO_FLAGS)

        If (i_me_error <> ME_ERRNO_SUCCESS) Then

            Exit Sub

        End If


        ' For the conversion ticks, the time that elapses between converting two 
        ' individual channels, we also require the minimum value.
        ' We call meIOStreamTimeToTicks with a time of zero and the function will return 
        ' the minimum tick value.

        i_conv_ticks_low = 0
        i_conv_ticks_high = 0

        d_time = 0.0

        i_me_error = meIOStreamTimeToTicks(giDeviceNumber, _
                                            giSubdeviceNumber, _
                                            ME_TIMER_CONV_START, _
                                            d_time, _
                                            i_conv_ticks_low, _
                                            i_conv_ticks_high, _
                                            ME_IO_FREQUENCY_TO_TICKS_NO_FLAGS)

        If (i_me_error <> ME_ERRNO_SUCCESS) Then

            Exit Sub

        End If

        ' We want to measure a range from -8.0 to +8.0 Volts for each channel
        ' We use the function meQueryRangeByMinMax to find the input range 
        ' which best matches our requirements.
        ' This function will always return the smallest range which covers 
        ' our required rang, if one exists. Otherwise, it will return the 
        ' largest range.
        ' The index of the range returned will be be passed to the routine 
        ' meIOStreamConfig below as part of the structure meIOStreamConfig_t 
        ' (parameter iStreamConfig).
        ' The function meQueryRangeByMinMax also returns the actual physical 
        ' and digital boundaries for the range which it has chosen for us.
        ' We will use the maximum digital value (the minimum digital value is 
        ' always 0) later when scaling the plot.

        d_phys_min = -8.0
        d_phys_max = +8.0

        i_me_error = meQueryRangeByMinMax(giDeviceNumber, _
                                            giSubdeviceNumber, _
                                            ME_UNIT_VOLT, _
                                            d_phys_min, _
                                            d_phys_max, _
                                            giDigitalMax, _
                                            i_range)

        If (i_me_error <> ME_ERRNO_SUCCESS) Then

            Exit Sub

        End If

        Dim arr_stream_config(3) As meIOStreamConfig_t

        arr_stream_config(0).iChannel = 0

        arr_stream_config(0).iStreamConfig = i_range
        arr_stream_config(0).iRef = ME_REF_AI_GROUND
        arr_stream_config(0).iFlags = ME_IO_STREAM_CONFIG_TYPE_NO_FLAGS

        arr_stream_config(1).iChannel = 1

        arr_stream_config(1).iStreamConfig = i_range
        arr_stream_config(1).iRef = ME_REF_AI_GROUND
        arr_stream_config(1).iFlags = ME_IO_STREAM_CONFIG_TYPE_NO_FLAGS

        arr_stream_config(2).iChannel = 2

        arr_stream_config(2).iStreamConfig = i_range
        arr_stream_config(2).iRef = ME_REF_AI_GROUND
        arr_stream_config(2).iFlags = ME_IO_STREAM_CONFIG_TYPE_NO_FLAGS

        arr_stream_config(3).iChannel = 3

        arr_stream_config(3).iStreamConfig = i_range
        arr_stream_config(3).iRef = ME_REF_AI_GROUND
        arr_stream_config(3).iFlags = ME_IO_STREAM_CONFIG_TYPE_NO_FLAGS

        Dim stream_trigger As New meIOStreamTrigger

        stream_trigger.Initialize()

        stream_trigger.iAcqStartTrigType = ME_TRIG_TYPE_SW

        ' int iAcqStartTrigEdge
        stream_trigger.iAcqStartTrigChan = ME_TRIG_CHAN_DEFAULT
        stream_trigger.iAcqStartTicksLow = i_acq_ticks_low
        stream_trigger.iAcqStartTicksHigh = i_acq_ticks_high
        ' int iAcqStartArgs[10]
        stream_trigger.iScanStartTrigType = ME_TRIG_TYPE_TIMER
        stream_trigger.iScanStartTicksLow = i_scan_ticks_low
        stream_trigger.iScanStartTicksHigh = i_scan_ticks_high
        ' int iScanStartArgs[10]
        stream_trigger.iConvStartTrigType = ME_TRIG_TYPE_TIMER
        stream_trigger.iConvStartTicksLow = i_conv_ticks_low
        stream_trigger.iConvStartTicksHigh = i_conv_ticks_high
        ' int iConvStartArgs[10]
        ' int iScanStopTrigType
        ' int iScanStopCount
        ' int iScanStopArgs[10]
        ' int iAcqStopTrigType
        ' int iAcqStopCount
        ' int iAcqStopArgs[10]
        stream_trigger.iFlags = ME_IO_STREAM_TRIGGER_TYPE_NO_FLAGS

        i_me_error = meIOStreamConfig(giDeviceNumber, _
                                        giSubdeviceNumber, _
                                        arr_stream_config(0), _
                                        4, _
                                        stream_trigger, _
                                        4, _
                                        ME_IO_STREAM_CONFIG_NO_FLAGS)

        If (i_me_error <> ME_ERRNO_SUCCESS) Then

            Exit Sub

        End If

        Dim stream_start As meIOStreamStart_t

        stream_start.iDevice = giDeviceNumber
        stream_start.iSubdevice = giSubdeviceNumber
        stream_start.iStartMode = ME_START_MODE_BLOCKING
        stream_start.iTimeOut = 5
        stream_start.iFlags = ME_IO_STREAM_START_TYPE_NO_FLAGS
        stream_start.iErrno = 0

        i_me_error = meIOStreamStart(stream_start, _
                                        1, _
                                        ME_IO_STREAM_START_NO_FLAGS)

        If (i_me_error <> ME_ERRNO_SUCCESS) Then

            Exit Sub

        End If

        gTimer = New Timer(gTimerDelegate, Me, 100, 100)

        gbDrawPlot = True

        cmdStart.Enabled = False
        cmdStop.Enabled = True

    End Sub

    Private Sub cmdStop_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdStop.Click

        Dim i_me_error As Integer

        gTimer.Dispose()

        gbDrawPlot = False

        Dim stream_stop As meIOStreamStop_t

        stream_stop.iDevice = giDeviceNumber
        stream_stop.iSubdevice = giSubdeviceNumber
        stream_stop.iStopMode = ME_STOP_MODE_IMMEDIATE
        stream_stop.iFlags = ME_IO_STREAM_STOP_TYPE_NO_FLAGS
        stream_stop.iErrno = 0

        i_me_error = meIOStreamStop(stream_stop, _
               1, _
               ME_IO_STREAM_STOP_NO_FLAGS)

        If (i_me_error <> ME_ERRNO_SUCCESS) Then

            Exit Sub

        End If

        cmdStart.Enabled = True
        cmdStop.Enabled = False

    End Sub

    Private Sub frmMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load

        Dim i_me_error As Integer

        Dim i_number_of_devices As Integer

        Dim i_index_device As Integer

        Dim i_vendor_id As Integer
        Dim i_device_id As Integer
        Dim i_serial_no As Integer
        Dim i_bus_type As Integer
        Dim i_bus_no As Integer
        Dim i_dev_no As Integer
        Dim i_func_no As Integer
        Dim i_plugged As Integer

        gTimerDelegate = AddressOf ReadData

        giDeviceNumber = -1 ' Number of used board.

        giSubdeviceNumber = -1 ' Number of used device.

        ' Search for an AI-Streaming subdevice in the system

        meErrorSetDefaultProc(ME_SWITCH_ENABLE)

        ' Open the driver system

        i_me_error = meOpen(0)

        If (i_me_error <> ME_ERRNO_SUCCESS) Then
            Exit Sub
        End If

        ' Query the number of devices

        i_me_error = meQueryNumberDevices(i_number_of_devices)

        If (i_me_error <> ME_ERRNO_SUCCESS) Then
            Exit Sub
        End If

        If (i_number_of_devices = 0) Then

            MessageBox.Show("No ME-iDS Devices found in system")

            i_me_error = meClose(0)

            Close()

            Exit Sub

        End If


        For i_index_device = 0 To i_number_of_devices - 1

            i_me_error = meQueryInfoDevice(i_index_device, _
                                            i_vendor_id, _
                                            i_device_id, _
                                            i_serial_no, _
                                            i_bus_type, _
                                            i_bus_no, _
                                            i_dev_no, _
                                            i_func_no, _
                                            i_plugged)

            If (i_plugged <> ME_PLUGGED_IN) Then

                Continue For

            End If

            i_me_error = meQuerySubdeviceByType(i_index_device, _
                                                 0, _
                                                 ME_TYPE_AI, _
                                                 ME_SUBTYPE_STREAMING, _
                                                 giSubdeviceNumber)

            If (i_me_error = ME_ERRNO_SUCCESS) Then

                giDeviceNumber = i_index_device

                Exit For

            End If

        Next i_index_device


        If (giSubdeviceNumber = -1) Then

            MessageBox.Show("No AI-Streaming sub-device found in system")

            i_me_error = meClose(0)

            Close()

            Exit Sub

        End If

        gdADCFrequency = 100.0#

        gdWindowWidth = 4.0#

        glPlotColor(0) = System.Drawing.Color.Red
        glPlotColor(1) = System.Drawing.Color.Green
        glPlotColor(2) = System.Drawing.Color.Blue
        glPlotColor(3) = System.Drawing.Color.White

        gdCurrentXPix = 0.0#

        gdXPixIncrement = CDbl(PlotArea.ClientRectangle.Width + 1) / gdWindowWidth / gdADCFrequency

        gdYPixelFactor = CDbl(PlotArea.ClientRectangle.Height + 1 - 20) / 65536.0#

        giLastXPixel = -1

        giLastYPixel(0) = -1
        giLastYPixel(1) = -1
        giLastYPixel(2) = -1
        giLastYPixel(3) = -1

        cmdStart.Enabled = True
        cmdStop.Enabled = False

        gbDrawPlot = False

    End Sub


    'UPGRADE_WARNING: Event frmMain.Resize may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
    Private Sub frmMain_Resize(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Resize

        gbDrawPlot = False

        Dim g As Graphics = PlotArea.CreateGraphics()

        Dim SBrush As New System.Drawing.SolidBrush(System.Drawing.Color.Black)

        g.DrawRectangle(Pens.Black, 0, 0, PlotArea.ClientRectangle.Width, PlotArea.ClientRectangle.Height)
        g.FillRectangle(SBrush, 0, 0, PlotArea.ClientRectangle.Width, PlotArea.ClientRectangle.Height)

        g.Dispose()

        PlotArea.Top = 10
        PlotArea.Left = 10
        PlotArea.Width = ClientRectangle.Width - 20
        PlotArea.Height = ClientRectangle.Height - 60

        cmdStart.Top = PlotArea.Bottom + 10
        cmdStop.Top = PlotArea.Bottom + 10
        cmdExit.Top = PlotArea.Bottom + 10

        gdCurrentXPix = 0.0#

        gdXPixIncrement = CDbl(PlotArea.ClientRectangle.Width + 1) / gdWindowWidth / gdADCFrequency

        gdYPixelFactor = CDbl(PlotArea.ClientRectangle.Height + 1 - 20) / CDbl(giDigitalMax)

        giLastXPixel = -1

        giLastYPixel(0) = -1
        giLastYPixel(1) = -1
        giLastYPixel(2) = -1
        giLastYPixel(3) = -1

        gbDrawPlot = True

    End Sub
End Class