﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using meIDS_CS;
using meIDSTools;

namespace TestConsole_meIOSingleWriteAnalog_CS
{
    class TestConsole_meIOSingleWriteAnalog
    {
        struct SAOStreamingSubddevice
        {
            public int m_iDeviceIndex;

            public int m_iSubdeviceIndex;
        };

         static void Main(string[] args)
         {
            int i_number_of_devices = TestConsoleGeneric.TestConsoleMEIDSProlog();

            if (i_number_of_devices <= 0)
            {
                return;
            }

	        // ---------------------------------------------------------------------

            // Count the number of AO-Streaming subdevice in the system

            int i_number_ao_streaming_subdevices = 0;

	        int i_me_error = 0;

	        for(int index_device = 0; index_device < i_number_of_devices; index_device++)
	        {
		        int i_vendor_id;
		        int i_device_id;
		        int i_serial_no;
		        int i_bus_type;
		        int i_bus_no;
		        int i_dev_no;
		        int i_func_no;
		        int i_plugged;
        		
		        i_me_error = meIDS.meQueryInfoDevice(	index_device,				// Device index
										                out i_vendor_id,				// Vendor ID returned here				
										                out i_device_id,				// Device ID returned here
										                out i_serial_no,				// Serial number returned here
										                out i_bus_type,				// Bus type returned here
										                out i_bus_no,					// Bus number returned here
										                out i_dev_no,					// Bus device number returned here
										                out i_func_no,					// Bus function number returned here
										                out i_plugged				);	// Plugged status returned here

		        if(i_plugged != meIDS.ME_PLUGGED_IN)
		        {
			        continue;
		        }

		        int index_subdevice = 0;
        		
		        int i_number_of_subdevices;

		        i_me_error = meIDS.meQueryNumberSubdevices(	index_device,				    // Device index
												            out i_number_of_subdevices);	// Number of subdevices returned here
        		
		        while(true)
		        {
			        i_me_error = meIDS.meQuerySubdeviceByType(  index_device,					    // Device
												                index_subdevice,				    // Begin search at this sub-device 
												                meIDS.ME_TYPE_AO,				    // Type of sub-device to search for
                                                                meIDS.ME_SUBTYPE_STREAMING,			// Sub-type of sub-device to search for
												                out index_subdevice	        );		// sub-device index returned here

			        if(i_me_error != meIDS.ME_ERRNO_SUCCESS)
			        {
				        break;
			        }

                    ++i_number_ao_streaming_subdevices;

			        if(++index_subdevice >= i_number_of_subdevices)
			        {
				        break;
			        }
		        }
	        }

            if (i_number_ao_streaming_subdevices == 0)
	        {
                System.Console.Write("****    No AO-Streaming sub-devices found in system    ****\n\n", i_me_error);

                System.Console.Write("Press any key to terminate\n\n");

                System.Console.ReadKey(true);

		        meIDS.meClose(0);
        		
		        return;
	        }

            // Make a list of the AO-Streaming sub-devices 

            SAOStreamingSubddevice[] arrSubdevices = new SAOStreamingSubddevice[i_number_ao_streaming_subdevices];

            i_number_ao_streaming_subdevices = 0;

	        for(int index_device = 0; index_device < i_number_of_devices; index_device++)
	        {
		        int i_vendor_id;
		        int i_device_id;
		        int i_serial_no;
		        int i_bus_type;
		        int i_bus_no;
		        int i_dev_no;
		        int i_func_no;
		        int i_plugged;
        		
		        i_me_error = meIDS.meQueryInfoDevice(	index_device,				// Device index
										                out i_vendor_id,			// Vendor ID returned here				
										                out i_device_id,			// Device ID returned here
										                out i_serial_no,			// Serial number returned here
										                out i_bus_type,				// Bus type returned here
										                out i_bus_no,				// Bus number returned here
										                out i_dev_no,				// Bus device number returned here
										                out i_func_no,				// Bus function number returned here
										                out i_plugged				);	// Plugged status returned here

		        if(i_plugged != meIDS.ME_PLUGGED_IN)
		        {
			        continue;
		        }

		        int index_subdevice = 0;
        		
		        int i_number_of_subdevices;

		        i_me_error = meIDS.meQueryNumberSubdevices(	index_device,				    // Device index
												            out i_number_of_subdevices);	// Number of subdevices returned here
        		
		        while(true)
		        {
			        i_me_error = meIDS.meQuerySubdeviceByType(  index_device,					// Device
												                index_subdevice,				// Begin search at this sub-device 
												                meIDS.ME_TYPE_AO,				// Type of sub-device to search for
                                                                meIDS.ME_SUBTYPE_STREAMING,		// Sub-type of sub-device to search for
												                out index_subdevice	         );	// sub-device index returned here

			        if(i_me_error != meIDS.ME_ERRNO_SUCCESS)
			        {
				        break;
			        }

                    arrSubdevices[i_number_ao_streaming_subdevices] = new SAOStreamingSubddevice();

                    arrSubdevices[i_number_ao_streaming_subdevices].m_iDeviceIndex = index_device;

                    arrSubdevices[i_number_ao_streaming_subdevices].m_iSubdeviceIndex = index_subdevice;

                    ++i_number_ao_streaming_subdevices;

			        if(++index_subdevice >= i_number_of_subdevices)
			        {
				        break;
			        }
		        }
	        }

            System.Console.Write("{0} AO streaming sub-devices found in System\n\n", i_number_ao_streaming_subdevices);

            for (int index_subdevice = 0; index_subdevice < i_number_ao_streaming_subdevices; index_subdevice++)
	        {
		        System.Console.Write("{0}.   Device: {1}  Sub-device: {2}\n",
			                            index_subdevice + 1,
			                            arrSubdevices[index_subdevice].m_iDeviceIndex,
			                            arrSubdevices[index_subdevice].m_iSubdeviceIndex	);
	        }

	        System.Console.Write("\n\nPress any key to continue\n");

            System.Console.ReadKey(true);

	        System.Console.Write("\n\n");

            string read_line;

            while(true)
	        {
		        int index_subdevice;

	            bool b_terminate = false;
            	
                if (i_number_ao_streaming_subdevices > 1)
		        {
			        while(true)
			        {
				        System.Console.Write("Choose Subdevice:\n\n");

                        for (index_subdevice = 0; index_subdevice < i_number_ao_streaming_subdevices; index_subdevice++)
				        {
		                    System.Console.Write("{0}.   Device: {1}  Sub-device: {2}\n",
					                                index_subdevice + 1,
					                                arrSubdevices[index_subdevice].m_iDeviceIndex,
					                                arrSubdevices[index_subdevice].m_iSubdeviceIndex		);
				        }

                        System.Console.Write("\nYour choice (1 - {0}) (RETURN to terminate): ", i_number_ao_streaming_subdevices); 

				        read_line = System.Console.ReadLine();
                        
				        System.Console.Write("\n\n");
        				
				        if(read_line.Length == 0)
				        {
					        b_terminate = true;
        					
					        break;
				        }
        				
				        index_subdevice = System.Convert.ToInt32(read_line);

                        if ((index_subdevice < 1) || (index_subdevice > i_number_ao_streaming_subdevices))
				        {
					        continue;
				        }

				        break;
			        }

			        if(b_terminate)
			        {
				        break;
			        }

			        --index_subdevice;
		        }
		        else
		        {
			        index_subdevice = 0;
		        }

		        if(b_terminate)
		        {
			        break;
		        }

                double d_req_freq = 2000.0;
                double d_achieved_freq = d_req_freq;

                int i_ticks_low = 0;
                int i_ticks_high = 0;

                i_me_error = meIDS.meIOStreamFrequencyToTicks(  arrSubdevices[index_subdevice].m_iDeviceIndex,		    // Device index
                                                                arrSubdevices[index_subdevice].m_iSubdeviceIndex,	    // Subdevice index, 
                                                                meIDS.ME_TIMER_CONV_START,							    // Timer used 
                                                                ref d_achieved_freq,									// Required frequency Hz, Achieved frequency returned here	 
                                                                out i_ticks_low,										// Lower 32 bits of the corresponding tick value returned here
                                                                out i_ticks_high,										// Upper 32 bits of the corresponding tick value returned here
                                                                meIDS.ME_IO_FREQUENCY_TO_TICKS_NO_FLAGS              );	// No flags

                if (i_me_error != meIDS.ME_ERRNO_SUCCESS)
                {
                    System.Console.Write("****    meIOStreamFrequencyToTicks - Error: {0}    ****\n\n", i_me_error);

                    System.Console.Write("Press any key to terminate\n\n");

                    System.Console.ReadKey(true);

                    meIDS.meClose(0);

                    return;
                }

                System.Console.Write("meIOStreamFrequencyToTicks - Required Freq: {0:F2} Achieved Freq: {1:F2} Ticks low: {2} Ticks high: {3}\n\n", d_req_freq, d_achieved_freq, i_ticks_low, i_ticks_high);

                // Configure the device

                meIDS.meIOStreamConfig_t[] arr_stream_config = new meIDS.meIOStreamConfig_t[1];

                arr_stream_config[0].iChannel = 0;

                arr_stream_config[0].iStreamConfig = 0;
                arr_stream_config[0].iRef = meIDS.ME_REF_AO_GROUND;
                arr_stream_config[0].iFlags = meIDS.ME_IO_STREAM_CONFIG_TYPE_NO_FLAGS;

                meIDS.meIOStreamTrigger_t stream_trigger = new meIDS.meIOStreamTrigger_t();

                stream_trigger.iAcqStartTrigType = meIDS.ME_TRIG_TYPE_SW;

                // int iAcqStartTrigEdge;
                stream_trigger.iAcqStartTrigChan = meIDS.ME_TRIG_CHAN_DEFAULT;
                stream_trigger.iAcqStartTicksLow = 0;
                stream_trigger.iAcqStartTicksHigh = 0;
                // int iAcqStartArgs[10];
                stream_trigger.iScanStartTrigType = meIDS.ME_TRIG_TYPE_FOLLOW;
                // stream_trigger.iScanStartTicksLow ;
                // stream_trigger.iScanStartTicksHigh;
                //int iScanStartArgs[10];

                stream_trigger.iConvStartTrigType = meIDS.ME_TRIG_TYPE_TIMER;
                stream_trigger.iConvStartTicksLow = i_ticks_low;
                stream_trigger.iConvStartTicksHigh = i_ticks_high;
                //int iConvStartArgs[10];

                // int iScanStopTrigType;
                // int iScanStopCount;
                // int iScanStopArgs[10];

                // int iAcqStopTrigType;
                // int iAcqStopCount;
                // int iAcqStopArgs[10];

                stream_trigger.iFlags = meIDS.ME_IO_STREAM_TRIGGER_TYPE_NO_FLAGS;

                i_me_error = meIDS.meIOStreamConfig(arrSubdevices[index_subdevice].m_iDeviceIndex,				    // Device index
                                                    arrSubdevices[index_subdevice].m_iSubdeviceIndex,			    // Subdevice index, 
                                                    ref arr_stream_config[0],				    // Pointer to an array of meIOStreamConfig_t structures
                                                    1,									    // Number of elements in the stream config array above
                                                    ref stream_trigger,					    // Pointer to an meIOStreamTrigger_t structure
                                                    0,									    // FIFO IRQ threshold
                                                    meIDS.ME_IO_STREAM_CONFIG_NO_FLAGS);	// No flags

                if (i_me_error != meIDS.ME_ERRNO_SUCCESS)
                {
                    System.Console.Write("****    meIOStreamConfig - Error: {0}    ****\n\n", i_me_error);

                    System.Console.Write("Press any key to terminate\n\n");

                    System.Console.ReadKey(true);

                    meIDS.meClose(0);

                    return;
                }

                // Fetch the range information for range index 0.
                // We want to create a signal that covers the entire digital range

                double d_phys_min;

                double d_phys_max;

                int i_digital_max;

                int i_unit;

                i_me_error = meIDS.meQueryRangeInfo( arrSubdevices[index_subdevice].m_iDeviceIndex,		// Device index
                                                    arrSubdevices[index_subdevice].m_iSubdeviceIndex,	// Subdevice index, 
                                                    0,										            // Range index
                                                    out i_unit,											// Unit returned here
                                                    out d_phys_min,										// Physical minimum returned here
                                                    out d_phys_max,										// Physical maximum returned here
                                                    out i_digital_max                               );	// Digital maximum value returned here

                if (i_me_error != meIDS.ME_ERRNO_SUCCESS)
                {
                    System.Console.Write("****    meQueryRangeInfo - Error: {0}    ****\n\n", i_me_error);

                    System.Console.Write("Press any key to terminate\n\n");

                    System.Console.ReadKey(true);

                    meIDS.meClose(0);

                    return;
                }

		        int[] i_buffer = new int[20000];

		        int i_count = 20000;

		        for(int index_value = 0; index_value < 20000; index_value++)
		        {
			        i_buffer[index_value] = index_value * i_digital_max / 20000;
		        }
        		
		        i_me_error = meIDS.meIOStreamWrite(	arrSubdevices[index_subdevice].m_iDeviceIndex,		    // Device index
										            arrSubdevices[index_subdevice].m_iSubdeviceIndex,	    // Subdevice index, 
										            meIDS.ME_WRITE_MODE_PRELOAD,							// Write mode 
										            ref i_buffer[0],										// Buffer containing the values to write
										            ref i_count,											// Size of buffer in data values - Number of data values returned here
										            meIDS.ME_IO_STREAM_WRITE_NO_FLAGS					);	// No flags

		        if(i_me_error != meIDS.ME_ERRNO_SUCCESS)
		        {
                    System.Console.Write("****    meIOStreamWrite - Error: {0}    ****\n\n", i_me_error);

                    System.Console.Write("Press any key to terminate\n\n");

                    System.Console.ReadKey(true);

			        break;
		        }

		        System.Console.Write("Press any key to start the output\n\n");
        			
		        System.Console.Write("Press the ESC key at any time to end the output\n\n");
        			
                System.Console.ReadKey(true);

	            meIDS.meIOStreamStart_t[] arr_stream_start = new meIDS.meIOStreamStart_t[1];

	            arr_stream_start[0].iDevice = arrSubdevices[index_subdevice].m_iDeviceIndex;
	            arr_stream_start[0].iSubdevice = arrSubdevices[index_subdevice].m_iSubdeviceIndex;
	            arr_stream_start[0].iStartMode = meIDS.ME_START_MODE_BLOCKING;
	            arr_stream_start[0].iTimeOut = 5;
	            arr_stream_start[0].iFlags = meIDS.ME_IO_STREAM_START_TYPE_NO_FLAGS;
	            arr_stream_start[0].iErrno = 0;
            	
	            i_me_error = meIDS.meIOStreamStart(	ref arr_stream_start[0],			    // Pointer to an array of meIOStreamStart_t structures 
									                1,								        // Number of elements in the stream start array above
									                meIDS.ME_IO_STREAM_START_NO_FLAGS	);	// No flags

	            if(i_me_error != meIDS.ME_ERRNO_SUCCESS)
	            {
                    System.Console.Write("****    meIOStreamStart - Error: {0}    ****\n\n", i_me_error);

                    System.Console.Write("Press any key to terminate\n\n");

                    System.Console.ReadKey(true);

		            meIDS.meClose(0);
            		
		            return;
	            }

		        System.Console.Write("Output started - \n\n");

		        bool b_falling = false;

		        while(true)
		        {
			        System.Console.Write("Press ESC to terminate or SPACE to add a new buffer\n\n");

			        while(true)
                    {
                        if(Console.KeyAvailable == true)
		                {
                            ConsoleKeyInfo cki = Console.ReadKey(true);

			                if(cki.Key == ConsoleKey.Escape)
			                {
						        b_terminate = true;
        						
				                break;
			                }
					        else if(cki.Key == ConsoleKey.Spacebar)
					        {
						        if(b_falling)
						        {
							        for(int index_value = 0; index_value < 20000; index_value++)
							        {
								        i_buffer[index_value] = index_value * i_digital_max / 20000;
							        }

							        b_falling = false;
						        }
						        else 
						        {
							        for(int index_value = 0; index_value < 20000; index_value++)
							        {
								        i_buffer[index_value] = (20000 - index_value) * i_digital_max / 20000;
							        }

							        b_falling = true;
						        }
        						
						        i_count = 20000;

		                        i_me_error = meIDS.meIOStreamWrite(	arrSubdevices[index_subdevice].m_iDeviceIndex,		    // Device index
										                            arrSubdevices[index_subdevice].m_iSubdeviceIndex,	    // Subdevice index, 
										                            meIDS.ME_WRITE_MODE_BLOCKING,							// Write mode 
										                            ref i_buffer[0],										// Buffer containing the values to write
										                            ref i_count,											// Size of buffer in data values - Number of data values returned here
										                            meIDS.ME_IO_STREAM_WRITE_NO_FLAGS					);	// No flags

						        break;
					        }
				        }
			        }

			        if(b_terminate)
			        {
				        break;
			        }
		        }

	            meIDS.meIOStreamStop_t[] arr_stream_stop = new meIDS.meIOStreamStop_t[1];

	            arr_stream_stop[0].iDevice = arrSubdevices[index_subdevice].m_iDeviceIndex;
	            arr_stream_stop[0].iSubdevice = arrSubdevices[index_subdevice].m_iSubdeviceIndex;
	            arr_stream_stop[0].iStopMode = meIDS.ME_STOP_MODE_IMMEDIATE;
	            arr_stream_stop[0].iFlags = meIDS.ME_IO_STREAM_STOP_TYPE_NO_FLAGS;
	            arr_stream_stop[0].iErrno = 0;

	            i_me_error = meIDS.meIOStreamStop(  ref arr_stream_stop[0],			    // Pointer to an array of meIOStreamStop_t structures  
								                    1,								    // Number of elements in the stream stop array above
								                    meIDS.ME_IO_STREAM_STOP_NO_FLAGS);	// No flags

	            if(i_me_error != meIDS.ME_ERRNO_SUCCESS)
	            {
                    System.Console.Write("****    meIOStreamStop - Error: {0}    ****\n\n", i_me_error);

                    System.Console.Write("Press any key to terminate\n\n");

                    System.Console.ReadKey(true);

		            meIDS.meClose(0);
            		
		            return;
	            }


		        System.Console.Write("Output ended\n\n");

		        System.Console.Write("Press any key to continue\n");
        		
                System.Console.ReadKey(true);
            }

	        // ---------------------------------------------------------------------
        	
	        meIDS.meClose(0);

            System.Console.Write("Program completed successfully - Press any key to terminate\n\n");

            System.Console.ReadKey(true);
        	
	        return;
        }
    }
}