// Con_meIOStreamWriteWraparound.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <stdio.h>
#include <conio.h>

#include <memory.h>

extern "C"
{
#include "..\\medriver.h"
#include "..\\meIDSToolsDLL.h"
}

#include "..\\TestConsoleGeneric.h"

#ifdef WIN64

#pragma comment (lib, "..\\meIDSmain64.lib")
#pragma comment (lib, "..\\meIDSTools64.lib")

#else

#pragma comment (lib, "..\\meIDSmain.lib")
#pragma comment (lib, "..\\meIDSTools.lib")

#endif

int _tmain(int argc, _TCHAR* argv[])
{
	// Call generic console function in parent directory to 
	// open system and list the available devices and subdevices.

	int i_number_of_devices = TestConsoleMEIDSProlog();

	if(i_number_of_devices <= 0)
	{
		return(-1);
	}

	// ---------------------------------------------------------------------
	
	int i_number_ao_streaming_subdevices = 0;

	int i_me_error;

	// Search for an AO-Streaming subdevice in the system

	for(int index_device = 0; index_device < i_number_of_devices; index_device++)
	{
		int i_vendor_id;
		int i_device_id;
		int i_serial_no;
		int i_bus_type;
		int i_bus_no;
		int i_dev_no;
		int i_func_no;
		int i_plugged;
		
		i_me_error = meQueryInfoDevice(	index_device,				// Device index
										&i_vendor_id,				// Vendor ID returned here - not required				
										&i_device_id,				// Device ID returned here - not required
										&i_serial_no,				// Serial number returned here - not required
										&i_bus_type,					// Bus type returned here - not required
										&i_bus_no,					// Bus number returned here - not required
										&i_dev_no,					// Bus device number returned here - not required
										&i_func_no,					// Bus function number returned here - not required
										&i_plugged				);	// Plugged status returned hee - not required

		if(i_plugged != ME_PLUGGED_IN)
		{
			continue;
		}


		int index_subdevice = 0;

		int i_number_of_subdevices;

		i_me_error = meQueryNumberSubdevices(	index_device,				// Device index
												&i_number_of_subdevices);	// Number of subdevices returned here
		
		while(true)
		{
			i_me_error = meQuerySubdeviceByType(index_device,				// Device
												index_subdevice,			// Begin search at this sub-device 
												ME_TYPE_AO,					// Type of sub-device to search for
												ME_SUBTYPE_STREAMING,		// Sub-type of sub-device to search for
												&index_subdevice		);	// sub-device index returned here

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				break;
			}
			
			++i_number_ao_streaming_subdevices;

			if(++index_subdevice >= i_number_of_subdevices)
			{
				break;
			}
		}
	}

	if(i_number_ao_streaming_subdevices == 0)
	{
		printf("****    No AO-Streaming sub-device found in system    ****\n\n");
		
		printf("Press any key to terminate\n");
		
		_getch();
		
		meClose(0);
		
		return -1;
	}

	struct SAOStreamingSubddevice
	{
		int	m_iDeviceIndex;

		int m_iSubdeviceIndex;
	};

	SAOStreamingSubddevice* arrSubdevices = new SAOStreamingSubddevice[i_number_ao_streaming_subdevices];

	i_number_ao_streaming_subdevices = 0;

	for(int index_device = 0; index_device < i_number_of_devices; index_device++)
	{
		int i_vendor_id;
		int i_device_id;
		int i_serial_no;
		int i_bus_type;
		int i_bus_no;
		int i_dev_no;
		int i_func_no;
		int i_plugged;
		
		i_me_error = meQueryInfoDevice(	index_device,				// Device index
										&i_vendor_id,				// Vendor ID returned here - not required				
										&i_device_id,				// Device ID returned here - not required
										&i_serial_no,				// Serial number returned here - not required
										&i_bus_type,				// Bus type returned here - not required
										&i_bus_no,					// Bus number returned here - not required
										&i_dev_no,					// Bus device number returned here - not required
										&i_func_no,					// Bus function number returned here - not required
										&i_plugged				);	// Plugged status returned hee - not required

		if(i_plugged != ME_PLUGGED_IN)
		{
			continue;
		}

		int index_subdevice = 0;
		
		int i_number_of_subdevices;

		i_me_error = meQueryNumberSubdevices(	index_device,				// Device index
												&i_number_of_subdevices);	// Number of subdevices returned here
		
		while(true)
		{
			i_me_error = meQuerySubdeviceByType(index_device,					// Device
												index_subdevice,				// Begin search at this sub-device 
												ME_TYPE_AO,						// Type of sub-device to search for
												ME_SUBTYPE_STREAMING,			// Sub-type of sub-device to search for
												&index_subdevice	);			// sub-device index returned here

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				break;
			}

			arrSubdevices[i_number_ao_streaming_subdevices].m_iDeviceIndex = index_device;

			arrSubdevices[i_number_ao_streaming_subdevices].m_iSubdeviceIndex = index_subdevice;

			++i_number_ao_streaming_subdevices;
			
			if(++index_subdevice >= i_number_of_subdevices)
			{
				break;
			}
		}
	}

	printf("%d AO streaming sub-devices found:\n\n", i_number_ao_streaming_subdevices);

	for(int index_subdevice = 0; index_subdevice < i_number_ao_streaming_subdevices; index_subdevice++)
	{
		printf("%2d.   Device: %2d  Sub-device: %2d\n",
				index_subdevice + 1,
				arrSubdevices[index_subdevice].m_iDeviceIndex,
				arrSubdevices[index_subdevice].m_iSubdeviceIndex	);
	}

	printf("\n\nPress any key to continue\n\n");

	getch();

	char buffer[512];
	
	while(true)
	{
		int index_subdevice;

		bool b_terminate = false;

		while(true)
		{
			printf("Choose sub_device:\n\n");

			for(index_subdevice = 0; index_subdevice < i_number_ao_streaming_subdevices; index_subdevice++)
			{
				printf("    %2d.   Device: %2d  Sub-device: %2d\n",
						index_subdevice + 1,
						arrSubdevices[index_subdevice].m_iDeviceIndex,
						arrSubdevices[index_subdevice].m_iSubdeviceIndex	);
			}

			printf("\nYour choice (1 - %2d) (RETURN to terminate): ", i_number_ao_streaming_subdevices);  

			gets(&buffer[0]);

			printf("\n\n");
			
			if(buffer[0] == 0)
			{
				b_terminate = true;
				
				break;
			}
			
			if( (sscanf(&buffer[0], "%d", &index_subdevice) != 1 ) )
			{
				continue;
			}

			if( (index_subdevice < 1)||(index_subdevice > i_number_ao_streaming_subdevices) )
			{
				continue;
			}

			--index_subdevice;

			break;
		}

		if(b_terminate)
		{
			break;
		}

		printf("Press any key to start the output\n\n");
			
		_getch();

		int i_shape;

		i_shape = MEIDS_TOOLS_WAVEGEN_SHAPE_NEG_RAMP;

		double d_amplitude;

		d_amplitude = 8.0;

		double d_offset;

		d_offset = 0.0;

		double d_frequency;

		d_frequency = 1.0;

		i_me_error = meIDSToolsWaveGen(	arrSubdevices[index_subdevice].m_iDeviceIndex, 
										arrSubdevices[index_subdevice].m_iSubdeviceIndex, 
										ME_UNIT_VOLT, 
										i_shape, 
										d_amplitude, 
										d_offset, 
										&d_frequency										);
		
		if(i_me_error != MEIDS_TOOLS_ERRNO_SUCCESS)
		{
			printf("****    meIDSToolsWaveGen returned error: %d    ****\n\n", i_me_error);
			
			printf("Press any key to terminate\n");
			
			_getch();
			
			meClose(0);
			
			return -1;
		}

		printf("Output started - Frequency: %f Hz\n\n", d_frequency);

		printf("Press 'I' to terminate immediately or 'L' to terminate on the last buffer value\n\n");

		bool b_terminate_immediately = false;

		while(true)
		{
			if( _kbhit() != 0 )
			{
				char ch = _getch();
				
				if( (ch == 'i')||(ch == 'I') )
				{
					b_terminate_immediately = true;
					
					break;
				}
				else if( (ch == 'l')||(ch == 'L') )
				{
					b_terminate_immediately = false;
					
					break;
				}
			}
		}

		meIOStreamStop_t arr_stream_stop[1];

		arr_stream_stop[0].iDevice = arrSubdevices[index_subdevice].m_iDeviceIndex;
		arr_stream_stop[0].iSubdevice = arrSubdevices[index_subdevice].m_iSubdeviceIndex;

		if(b_terminate_immediately)
		{
			arr_stream_stop[0].iStopMode = ME_STOP_MODE_IMMEDIATE;
		}
		else
		{
			arr_stream_stop[0].iStopMode = ME_STOP_MODE_LAST_VALUE;
		}

		arr_stream_stop[0].iFlags = ME_IO_STREAM_STOP_TYPE_NO_FLAGS;
		arr_stream_stop[0].iErrno = 0;

		i_me_error = meIOStreamStop(&arr_stream_stop[0],			// Pointer to an array of meIOStreamStop_t structures  
									1,								// Number of elements in the stream stop array above
									ME_IO_STREAM_STOP_NO_FLAGS);	// No flags

		if(i_me_error != ME_ERRNO_SUCCESS)
		{
			printf("****    meIOStreamStop - Error: %d    ****\n\n", i_me_error);

			printf("Press any key to terminate\n");
			
			_getch();
		
			meClose(0);
		
			return(-1);
		}

		printf("Output ended\n\n");

		printf("Press any key to continue\n");
		
		_getch();
	}

	// ---------------------------------------------------------------------
	

	meClose(0);
	
	printf("Program completed successfully - Press any key to terminate\n\n");

	_getch();
	
	return 0;
}

