// Con_meIOFrequencyIn.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <stdio.h>
#include <conio.h>

#include <memory.h>

#include <string.h>

extern "C"
{
#include "..\\medriver.h"
}

#include "..\\TestConsoleGeneric.h"

#ifdef WIN64

#pragma comment (lib, "..\\meIDSmain64.lib")

#else

#pragma comment (lib, "..\\meIDSmain.lib")

#endif

int _tmain(int argc, _TCHAR* argv[])
{
	// Call generic console function in parent directory to 
	// open system and list the available devices and subdevices.

	int i_number_of_devices = TestConsoleMEIDSProlog();

	if(i_number_of_devices <= 0)
	{
		return(-1);
	}

	// ---------------------------------------------------------------------
	
	// Count the Counter sub-devices in the system

	int i_number_fi_subdevices = 0;

	int i_me_error;

	for(int index_device = 0; index_device < i_number_of_devices; index_device++)
	{
		int i_vendor_id;
		int i_device_id;
		int i_serial_no;
		int i_bus_type;
		int i_bus_no;
		int i_dev_no;
		int i_func_no;
		int i_plugged;
		
		i_me_error = meQueryInfoDevice(	index_device,				// Device index
										&i_vendor_id,				// Vendor ID returned here - not required				
										&i_device_id,				// Device ID returned here - not required
										&i_serial_no,				// Serial number returned here - not required
										&i_bus_type,				// Bus type returned here - not required
										&i_bus_no,					// Bus number returned here - not required
										&i_dev_no,					// Bus device number returned here - not required
										&i_func_no,					// Bus function number returned here - not required
										&i_plugged				);	// Plugged status returned hee - not required

		if(i_plugged != ME_PLUGGED_IN)
		{
			continue;
		}

		int index_subdevice = 0;

		int i_number_of_subdevices;

		i_me_error = meQueryNumberSubdevices(	index_device,				// Device index
												&i_number_of_subdevices);	// Number of subdevices returned here
		
		while(true)
		{
			i_me_error = meQuerySubdeviceByType(index_device,					// Device
												index_subdevice,				// Begin search at this sub-device 
												ME_TYPE_FI,						// Type of sub-device to search for
												ME_SUBTYPE_ANY,					// Sub-type of sub-device to search for
												&index_subdevice	);			// sub-device index returned here

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				break;
			}
			
			++i_number_fi_subdevices;

			if(++index_subdevice >= i_number_of_subdevices)
			{
				break;
			}
		}
	}

	if(i_number_fi_subdevices == 0)
	{
		printf("****    No FI sub-devices found in system    ****\n\n");
		
		printf("Press any key to terminate\n");
		
		_getch();
		
		meClose(0);
		
		return -1;
	}

	// Make a list of the FI sub-devices

	struct SFISubddevice
	{
		int	m_iDeviceIndex;

		int m_iSubdeviceIndex;
	};

	SFISubddevice* arrSubdevices = new SFISubddevice[i_number_fi_subdevices];

	i_number_fi_subdevices = 0;

	for(int index_device = 0; index_device < i_number_of_devices; index_device++)
	{
		int i_vendor_id;
		int i_device_id;
		int i_serial_no;
		int i_bus_type;
		int i_bus_no;
		int i_dev_no;
		int i_func_no;
		int i_plugged;
		
		i_me_error = meQueryInfoDevice(	index_device,				// Device index
										&i_vendor_id,				// Vendor ID returned here - not required				
										&i_device_id,				// Device ID returned here - not required
										&i_serial_no,				// Serial number returned here - not required
										&i_bus_type,				// Bus type returned here - not required
										&i_bus_no,					// Bus number returned here - not required
										&i_dev_no,					// Bus device number returned here - not required
										&i_func_no,					// Bus function number returned here - not required
										&i_plugged				);	// Plugged status returned hee - not required

		if(i_plugged != ME_PLUGGED_IN)
		{
			continue;
		}

		int index_subdevice = 0;
		
		int i_number_of_subdevices;

		i_me_error = meQueryNumberSubdevices(	index_device,				// Device index
												&i_number_of_subdevices);	// Number of subdevices returned here
		
		while(true)
		{
			i_me_error = meQuerySubdeviceByType(index_device,					// Device
												index_subdevice,				// Begin search at this sub-device 
												ME_TYPE_FI,						// Type of sub-device to search for
												ME_SUBTYPE_ANY,					// Sub-type of sub-device to search for
												&index_subdevice	);			// sub-device index returned here

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				break;
			}

			arrSubdevices[i_number_fi_subdevices].m_iDeviceIndex = index_device;

			arrSubdevices[i_number_fi_subdevices].m_iSubdeviceIndex = index_subdevice;

			++i_number_fi_subdevices;

			if(++index_subdevice >= i_number_of_subdevices)
			{
				break;
			}
		}
	}

	printf("%d FI sub-devices found:\n\n", i_number_fi_subdevices);

	for(int index_subdevice = 0; index_subdevice < i_number_fi_subdevices; index_subdevice++)
	{
		printf("%2d.   Device: %2d  Sub-device: %2d\n",
				index_subdevice + 1,
				arrSubdevices[index_subdevice].m_iDeviceIndex,
				arrSubdevices[index_subdevice].m_iSubdeviceIndex					);
	}


	printf("\n\nPress any key to continue\n\n");

	getch();

	char buffer[512];
	
	while(true)
	{
		int index_subdevice = 0;

		int i_number_function;

		bool b_terminate = false;

		if(i_number_fi_subdevices > 1)
		{
			while(true)
			{
				printf("Choose sub-device:\n\n");

				for(index_subdevice = 0; index_subdevice < i_number_fi_subdevices; index_subdevice++)
				{
					printf("%2d.   Device: %2d  Sub-device: %2d\n",
							index_subdevice + 1,
							arrSubdevices[index_subdevice].m_iDeviceIndex,
							arrSubdevices[index_subdevice].m_iSubdeviceIndex					);
				}

				printf("\nYour choice (1 - %2d) (RETURN to terminate): ", i_number_fi_subdevices);  

				gets(&buffer[0]);

				printf("\n\n");
				
				if(buffer[0] == 0)
				{
					b_terminate = true;
					
					break;
				}
				
				if( (sscanf(&buffer[0], "%d", &index_subdevice) != 1 ) )
				{
					continue;
				}

				if( (index_subdevice < 1)||(index_subdevice > i_number_fi_subdevices) )
				{
					continue;
				}

				--index_subdevice;

				break;
			}
		}

		if(b_terminate)
		{
			break;
		}
			
		int i_number_of_channels = 0;
		
		i_me_error = meQueryNumberChannels(	arrSubdevices[index_subdevice].m_iDeviceIndex,		// Device index
											arrSubdevices[index_subdevice].m_iSubdeviceIndex,	// Subdevice index
											&i_number_of_channels							);	// number of channels returned here
		
		
		int index_channel = 0;

		if(i_number_of_channels > 1)
		{
			while(true)
			{
				printf("Choose channel 0 - %2d ((RETURN to terminate): ", i_number_of_channels - 1);

				gets(&buffer[0]);

				printf("\n\n");
				
				if(buffer[0] == 0)
				{
					b_terminate = true;
					
					break;
				}
				
				if( (sscanf(&buffer[0], "%d", &index_channel) != 1 ) )
				{
					continue;
				}

				if( (index_channel < 0)||(index_channel >= i_number_of_channels) )
				{
					continue;
				}

				break;
			}
		}
		
		if(b_terminate)
		{
			break;
		}

		printf(	"Using Device: %d    Sub-device: %d    Channel: %d\n\n", 
				arrSubdevices[index_subdevice].m_iDeviceIndex, 
				arrSubdevices[index_subdevice].m_iSubdeviceIndex, 
				index_channel											);
			
		while(true)
		{
			printf("Choose function:\n\n");

			printf(	"1. Reset\n"
					"2. Config\n"
					"3. Read\n\n");

			printf("\nYour choice (1 - 3) (RETURN to terminate): ");  

			gets(&buffer[0]);

			printf("\n\n");
			
			if(buffer[0] == 0)
			{
				b_terminate = true;
				
				break;
			}
			
			if( (sscanf(&buffer[0], "%d", &i_number_function) != 1 ) )
			{
				continue;
			}

			if( (i_number_function < 1)||(i_number_function > 3) )
			{
				continue;
			}

			break;
		}

		if(b_terminate)
		{
			break;
		}

		int b_cancel = false;

		switch(i_number_function)
		{
		case 1:	// Reset

	        printf(	"Press any key to call:\n\n"
			        "    meIOResetSubdevice( %-30d      (iDevice)\n"
			        "                        %-30d      (iSubdevice)\n"							
			        "                        %-30s  );  (iFlags)\n\n",
			        arrSubdevices[index_subdevice].m_iDeviceIndex,
			        arrSubdevices[index_subdevice].m_iSubdeviceIndex,
		            "ME_IO_RESET_SUBDEVICE_NO_FLAGS"						);


			getch();

			i_me_error = meIOResetSubdevice(arrSubdevices[index_subdevice].m_iDeviceIndex,		// Device index
											arrSubdevices[index_subdevice].m_iSubdeviceIndex,	// Subdevice index
											ME_IO_RESET_SUBDEVICE_NO_FLAGS					);	// Flags

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				printf("****    meIOResetSubdevice - Error: %d    ****\n\n", i_me_error);

				printf("Press any key to terminate\n");
				
				_getch();
				
				meClose(0);
				
				return -1;
			}

			printf("Device: %d Subdevice: %d reset, press any key to continue\n\n", arrSubdevices[index_subdevice].m_iDeviceIndex, arrSubdevices[index_subdevice].m_iSubdeviceIndex);

			_getch();

			break;

		case 2: // Config

	        printf(	"Press any key to call:\n\n"
			        "    meIOSingleConfig( %-35d      (iDevice)\n"
			        "                      %-35d      (iSubdevice)\n"							
			        "                      %-35d      (iChannel)\n"							
			        "                      %-35s      (iSingleConfig)\n"							
			        "                      %-35s      (iRef)\n"							
			        "                      %-35s      (iTrigChan)\n"							
			        "                      %-35s      (iTrigType)\n"							
			        "                      %-35s      (iTrigEdge)\n"							
			        "                      %-35s  );  (iFlags)\n\n",
			        arrSubdevices[index_subdevice].m_iDeviceIndex,
			        arrSubdevices[index_subdevice].m_iSubdeviceIndex,
                    index_channel,
                    "ME_SINGLE_CONFIG_FIO_INPUT",
                    "ME_VALUE_NOT_USED",
                    "ME_TRIG_CHAN_DEFAULT",
                    "ME_TRIG_TYPE_NONE",
                    "ME_VALUE_NOT_USED",
		            "ME_IO_SINGLE_CONFIG_NO_FLAGS"						);

            getch();

			i_me_error = meIOSingleConfig(	arrSubdevices[index_subdevice].m_iDeviceIndex,		// Device index
											arrSubdevices[index_subdevice].m_iSubdeviceIndex,	// Subdevice index
											index_channel,										// Channel
											ME_SINGLE_CONFIG_FIO_INPUT,							// Single config
											ME_VALUE_NOT_USED,									// Reference 
											ME_TRIG_CHAN_DEFAULT,								// Trigger channel
											ME_TRIG_TYPE_NONE,									// Trigger type
											ME_VALUE_NOT_USED,									// Trigger edge
											ME_IO_SINGLE_CONFIG_NO_FLAGS					);	// Flags

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				printf("****    meIOSingleConfig - Error: %d    ****\n\n", i_me_error);

				printf("Press any key to terminate\n");
				
				_getch();
				
				meClose(0);
				
				return -1;
			}

			printf("Device: %d Subdevice: %d Channel: %d has been configured - press any key to continue\n\n", arrSubdevices[index_subdevice].m_iDeviceIndex, arrSubdevices[index_subdevice].m_iSubdeviceIndex, index_channel);

			getch();
			
			break;

		case 3: // Read

			int i_flags;
			
			i_flags = ME_IO_SINGLE_TYPE_NO_FLAGS;

			int i_single_flag;
			
			int i_timeout_ms = 0;

			while(true)
			{
				printf("Choose return mode:\n\n");

				printf(	"1. Next value (No flags)\n"
						"2. Last value ('ME_IO_SINGLE_TYPE_FI_LAST_VALUE')\n\n"				);

				printf("Choose return mode (1 - 2) (RETURN to cancel): ");  

				gets(&buffer[0]);

				printf("\n\n");
				
				if(buffer[0] == 0)
				{
					b_cancel = true;
					
					break;
				}

				if( (sscanf(&buffer[0], "%d", &i_single_flag) != 1 ) )
				{
					continue;
				}

				if( (i_single_flag < 1)||(i_single_flag > 2 ) )
				{
					continue;
				}

				if(i_single_flag == 2)
				{
					i_flags|= ME_IO_SINGLE_TYPE_FI_LAST_VALUE;
				}

				break;
			}

			if(b_cancel)
			{
				break;
			}

			while(true)
			{
				printf("Timeout milliseconds (0  - 10000, 0 --> No Timeout) (RETURN to terminate): ");

				gets(&buffer[0]);

				printf("\n\n");
				
				if(buffer[0] == 0)
				{
					b_cancel = true;

					break;
				}
				
				if( (sscanf(&buffer[0], "%d", &i_timeout_ms) != 1 ) )
				{
					continue;
				}

				if( (i_timeout_ms < 0)||(10000 < i_timeout_ms) )
				{
					continue;
				}

				break;
			}

			if(b_cancel)
			{
				break;
			}

			while(true)
			{
				printf("Choose return type:\n\n");

				printf(	"1. Ticks total ('ME_IO_SINGLE_TYPE_FIO_TICKS_TOTAL')\n"
						"2. Ticks first phase ('ME_IO_SINGLE_TYPE_FIO_TICKS_FIRST_PHASE')\n\n"				);

				printf("Choose return type (1 - 2) (RETURN to cancel): ");  

				gets(&buffer[0]);

				printf("\n\n");
				
				if(buffer[0] == 0)
				{
					b_cancel = true;
					
					break;
				}
				
				if( (sscanf(&buffer[0], "%d", &i_single_flag) != 1 ) )
				{
					continue;
				}

				if( (i_single_flag < 1)||(i_single_flag > 2 ) )
				{
					continue;
				}

				if(i_single_flag == 1)
				{
					i_flags|= ME_IO_SINGLE_TYPE_FIO_TICKS_TOTAL;
				}
				else // if(i_single_flag == 2)
				{
					i_flags|= ME_IO_SINGLE_TYPE_FIO_TICKS_FIRST_PHASE;
				}

				break;
			}

			if(b_cancel)
			{
				break;
			}

			char sz_st_flags[128];

			sz_st_flags[0] = 0;
			
			int b_first_flag = 1;

			if( (i_flags & ME_IO_SINGLE_TYPE_FIO_TICKS_TOTAL) == ME_IO_SINGLE_TYPE_FIO_TICKS_TOTAL )
			{
				if(b_first_flag == 0)
				{
					strcat(&sz_st_flags[0], " | ");
				}

				strcat(&sz_st_flags[0], "ME_IO_SINGLE_TYPE_FIO_TICKS_TOTAL");

				b_first_flag = 0;
			}
			else if( (i_flags & ME_IO_SINGLE_TYPE_FIO_TICKS_FIRST_PHASE) == ME_IO_SINGLE_TYPE_FIO_TICKS_FIRST_PHASE )
			{
				if(b_first_flag == 0)
				{
					strcat(&sz_st_flags[0], " | ");
				}

				strcat(&sz_st_flags[0], "ME_IO_SINGLE_TYPE_FIO_TICKS_FIRST_PHASE");

				b_first_flag = 0;
			}

			if( (i_flags & ME_IO_SINGLE_TYPE_FI_LAST_VALUE) == ME_IO_SINGLE_TYPE_FI_LAST_VALUE )
			{
				if(b_first_flag == 0)
				{
					strcat(&sz_st_flags[0], " | ");
				}

				strcat(&sz_st_flags[0], "ME_IO_SINGLE_TYPE_FREQ_LAST_VALUE");

				b_first_flag = 0;
			}

	        printf(	"Press any key to call:\n\n"
			        "    meIOSingle( %-30s      (*pSingleList)\n"
			        "                %-30d      (iCount)\n"							
			        "                %-30s  );  (iFlags)\n\n",
			        "&io_single[0]",
                    1,
		            "ME_IO_SINGLE_NO_FLAGS"						);

	        printf(	"Where 'io_single' is an array of length one of meIOSingle_t structures:\n\n"
                    "    meIOSingle_t io_single[1]\n\n"
                    "and the first and only element of this array is filled as follows:\n\n"
			        "    %-30s = %-30d      (iDevice)\n"
			        "    %-30s = %-30d      (iSubdevice)\n"
			        "    %-30s = %-30d      (iChannel)\n"
			        "    %-30s = %-30s      (iDir)\n"
			        "    %-30s = %-30d      (iValue) - Result returned here\n"
			        "    %-30s = %-30d      (iTimeOut)\n"
			        "    %-30s = %-30s      (iFlags)\n\n",
                    "io_single[0].iDevice",
			        arrSubdevices[index_subdevice].m_iDeviceIndex,
                    "io_single[0].iSubdevice",
			        arrSubdevices[index_subdevice].m_iSubdeviceIndex,
                    "io_single[0].iChannel",
                    index_channel,
                    "io_single[0].iDir",
                    "ME_DIR_INPUT",
                    "io_single[0].iValue",
                    0,
                    "io_single[0].iTimeOut",
                    i_timeout_ms,
                    "io_single[0].iFlags",
		            &sz_st_flags[0]															);

            getch();

			meIOSingle_t io_single[1];

			io_single[0].iDevice = arrSubdevices[index_subdevice].m_iDeviceIndex;

			io_single[0].iSubdevice = arrSubdevices[index_subdevice].m_iSubdeviceIndex;
			io_single[0].iChannel	= index_channel;
			io_single[0].iDir		= ME_DIR_INPUT;
			io_single[0].iValue		= 0;
			io_single[0].iTimeOut	= i_timeout_ms;		
			io_single[0].iFlags		= i_flags;
			
			i_me_error = meIOSingle(&io_single[0],				// Output list 
									1,							// Number of elements in the above list 
									ME_IO_SINGLE_NO_FLAGS	);	// Flags

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				printf("****    meIOSingle - Error: %d    ****\n\n", i_me_error);

				printf("Press any key to terminate\n");
				
				_getch();
				
				meClose(0);
				
				return -1;
			}

			int i_timer;

			if( (i_flags & ME_IO_SINGLE_TYPE_FIO_TICKS_TOTAL) == ME_IO_SINGLE_TYPE_FIO_TICKS_TOTAL )
			{
				i_timer = ME_TIMER_FIO_TOTAL;
			}
			else if( (i_flags & ME_IO_SINGLE_TYPE_FIO_TICKS_FIRST_PHASE) == ME_IO_SINGLE_TYPE_FIO_TICKS_FIRST_PHASE )
			{
				i_timer = ME_TIMER_FIO_FIRST_PHASE;
			}

			double d_time;

			i_me_error = meIOSingleTicksToTime(	arrSubdevices[index_subdevice].m_iDeviceIndex,			// Device
												arrSubdevices[index_subdevice].m_iSubdeviceIndex,		// Sub-device
												i_timer,												// iTimer
												io_single[0].iValue,									// Ticks low
												0,														// Ticks high
												&d_time,												// Corresponding time returned here
												ME_IO_SINGLE_TICKS_TO_TIME_NO_FLAGS					);	// flags
			
			printf(	"Read %d ticks (%g seconds) from Device: %d Subdevice: %d Channel: %d, press any key to continue\n\n", 
					io_single[0].iValue, 
					d_time, 
					arrSubdevices[index_subdevice].m_iDeviceIndex, 
					arrSubdevices[index_subdevice].m_iSubdeviceIndex,
					index_channel																							);

			_getch();

			break;
		}
	}

	delete []arrSubdevices;

	// ---------------------------------------------------------------------
	
	meClose(0);
	
	printf("Program completed successfully - Press any key to terminate\n\n");

	_getch();
	
	return 0;
}

