// Dlg_M-7_Test.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Dlg_M-7_Test.h"
#include "Dlg_M-7_TestDlg.h"

extern "C"
{
#include "..\\medriver.h"
}

#ifdef WIN64

#pragma comment (lib, "..\\meIDSmain64.lib")

#else

#pragma comment (lib, "..\\meIDSmain.lib")

#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CDlg_M7_TestApp

BEGIN_MESSAGE_MAP(CDlg_M7_TestApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// CDlg_M7_TestApp construction

CDlg_M7_TestApp::CDlg_M7_TestApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CDlg_M7_TestApp object

CDlg_M7_TestApp theApp;


// CDlg_M7_TestApp initialization

BOOL CDlg_M7_TestApp::InitInstance()
{
	// InitCommonControlsEx() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// Set this to include all the common control classes you want to use
	// in your application.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinApp::InitInstance();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	meErrorSetDefaultProc(ME_SWITCH_ENABLE);

	// Open the driver system

	int i_me_error = meOpen(0);

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		return(-1);
	}

	// Query the number of devices

	int i_number_of_devices;
	
	i_me_error = meQueryNumberDevices(&i_number_of_devices);

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		return(-1);
	}

	if(i_number_of_devices == 0)
	{
		AfxMessageBox(L"No ME-IDS devices found in system");

		return(-1);
	}

	int i_ME7_device_index = -1;

	int i_ME7_number_of_current_channels = 0;
	
	for(int index_device = 0; index_device < i_number_of_devices; index_device++)
	{
		int i_vendor_id;
		int i_device_id;
		int i_serial_no;
		int i_bus_type;
		int i_bus_no;
		int i_dev_no;
		int i_func_no;
		int i_plugged;

		i_me_error = meQueryInfoDevice(index_device, &i_vendor_id, &i_device_id, &i_serial_no, 
												&i_bus_type, &i_bus_no, &i_dev_no, &i_func_no, &i_plugged);

		if(i_me_error != ME_ERRNO_SUCCESS)
		{
			return(-1);
		}

		if( (i_device_id & 0x0000FF00) == 0x00000700 )
		{
			i_ME7_device_index = index_device;

			i_ME7_number_of_current_channels = i_device_id & 0x0000000F;

			break;
		}
	}		

	if(i_ME7_device_index == -1)
	{
		AfxMessageBox(L"No ME-7 device found in system");

		return(-1);
	}

	int i_ME7_AI_subdevice_index = -1;

	i_me_error = meQuerySubdeviceByType(i_ME7_device_index,				// Device
										0,								// Begin search at this sub-device 
										ME_TYPE_AI,						// Type of sub-device to search for
										ME_SUBTYPE_ANY,					// Sub-type of sub-device to search for
										&i_ME7_AI_subdevice_index	);	// sub-device index returned here

	CDlg_M7_TestDlg dlg;

	dlg.m_iME7DeviceIndex = i_ME7_device_index;

	dlg.m_iME7AISubdeviceIndex = i_ME7_AI_subdevice_index;

	dlg.m_iNumberOfCurrentChannels = i_ME7_number_of_current_channels;

	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
