// TestDialog_StreamRead_CallbackDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Dlg_StreamRead_Callback.h"
#include "Dlg_StreamRead_CallbackDlg.h"

#ifdef WIN64

#pragma comment (lib, "..\\meIDSmain64.lib")

#else

#pragma comment (lib, "..\\meIDSmain.lib")

#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestDialog_StreamRead_CallbackDlg dialog




CTestDialog_StreamRead_CallbackDlg::CTestDialog_StreamRead_CallbackDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDialog_StreamRead_CallbackDlg::IDD, pParent)
	, m_dScanFrequency(100.0)
	, m_iSampleCounter(10)
	, m_bEnableChannel1(TRUE)
	, m_bEnableChannel2(TRUE)
	, m_bEnableChannel3(TRUE)
	, m_bEnableChannel4(TRUE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestDialog_StreamRead_CallbackDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_SCAN_FREQUENCY, m_dScanFrequency);
	DDX_Text(pDX, IDC_EDIT_SAMPLE_COUNTER, m_iSampleCounter);
	DDX_Check(pDX, IDC_CHECK_CHANNEL_1, m_bEnableChannel1);
	DDX_Check(pDX, IDC_CHECK_CHANNEL_2, m_bEnableChannel2);
	DDX_Check(pDX, IDC_CHECK_CHANNEL_3, m_bEnableChannel3);
	DDX_Check(pDX, IDC_CHECK_CHANNEL_4, m_bEnableChannel4);
}

BEGIN_MESSAGE_MAP(CTestDialog_StreamRead_CallbackDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START, &CTestDialog_StreamRead_CallbackDlg::OnBnClickedStart)
	ON_BN_CLICKED(IDC_STOP, &CTestDialog_StreamRead_CallbackDlg::OnBnClickedStop)
END_MESSAGE_MAP()

void CTestDialog_StreamRead_CallbackDlg :: SetAIStreamingSubdevice(int iIndexSubdevice)
{
	m_iDevice = m_arrAIStreamingSubdevices[iIndexSubdevice].m_iDeviceNumber;
	
	m_iSubdevice = m_arrAIStreamingSubdevices[iIndexSubdevice].m_iSubdeviceNumber;
	
	char sz_device_name[64];
	
	int i_me_error = meQueryNameDevice(	m_iDevice,				// Device index 
										&sz_device_name[0],		// Buffer to contain device name		
										64					);	// Size of buffer

	GetDlgItem(IDC_DEVICE)->SetWindowText(&sz_device_name[0]);

	int i_vendor_id;
	int i_device_id;
	int i_serial_no;
	int i_bus_type;
	int i_bus_no;
	int i_dev_no;
	int i_func_no;
	int i_plugged;
	
	i_me_error = meQueryInfoDevice(	m_iDevice,					// Device index
									&i_vendor_id,				// Vendor ID returned here - not required				
									&i_device_id,				// Device ID returned here - not required
									&i_serial_no,				// Serial number returned here - not required
									&i_bus_type,					// Bus type returned here - not required
									&i_bus_no,					// Bus number returned here - not required
									&i_dev_no,					// Bus device number returned here - not required
									&i_func_no,					// Bus function number returned here - not required
									&i_plugged				);	// Plugged status returned hee - not required

	sprintf(&sz_device_name[0], "%08X", i_serial_no);

	GetDlgItem(IDC_SERIAL_NUMBER)->SetWindowText(&sz_device_name[0]);

	i_me_error = meIOStreamSetCallbacks(m_iDevice,								// Device index
										m_iSubdevice,							// Subdevice index
										NULL,									// Start callback
										NULL,									// Start callback context
										StreamReadNewValuesCallback,			// New values callback
										this,									// New values callback context
										NULL,									// End callback
										NULL,									// End callback context
										ME_IO_STREAM_SET_CALLBACKS_NO_FLAGS	);	// Flags
}

#define MAX_DIGITAL_VALUES	1000

int arriMultiplexedDigitalData[MAX_DIGITAL_VALUES];

int arriChannelDigitalData[MAX_DIGITAL_VALUES];

int _stdcall CTestDialog_StreamRead_CallbackDlg :: StreamReadNewValuesCallback(int iDevice, int iSubdevice, int iCount, void *pvContext, int iErrorCode)
{

	if(iErrorCode != ME_ERRNO_SUCCESS)
	{
		char sz_error[128];

		meErrorGetMessage(iErrorCode, &sz_error[0], 128);
		
		char sz_buffer[256];
		sprintf( &sz_buffer[0], "Callback - Error code: %d - <%s>", iErrorCode, &sz_error[0] );

		AfxMessageBox( &sz_buffer[0] );

		return(-1);
	}

	CTestDialog_StreamRead_CallbackDlg* p_srcDlg = (CTestDialog_StreamRead_CallbackDlg *)pvContext;

	int no_of_frames = iCount / p_srcDlg->m_iNumberOfChannels;

	if(no_of_frames <= 0)
	{
		return(0);
	}

	CClientDC dc(p_srcDlg);
	
	dc.IntersectClipRect(p_srcDlg->m_rectPlot);
	
	CRect rect_erase = p_srcDlg->m_rectPlot;
	
	CPen* p_old_pen = (CPen*)dc.SelectStockObject(BLACK_PEN);

	if( !p_srcDlg->m_bFirstDraw )
	{
		dc.MoveTo(p_srcDlg->m_iXLastPixel + 1, p_srcDlg->m_rectPlot.top);
		dc.LineTo(p_srcDlg->m_iXLastPixel + 1, p_srcDlg->m_rectPlot.bottom);

		int erase_from_pixel = p_srcDlg->m_iXLastPixel + 1;
		
		int erase_to_pixel = (int)(p_srcDlg->m_iXLastPixel + (double)no_of_frames * p_srcDlg->m_dXIncrement);

		if(erase_to_pixel > erase_from_pixel)
		{
			if( erase_to_pixel > p_srcDlg->m_rectPlot.right )
			{
				rect_erase.left = erase_from_pixel;
				
				dc.FillSolidRect( rect_erase, RGB(0, 0, 0) );

				erase_from_pixel = p_srcDlg->m_rectPlot.left;
				erase_to_pixel-= p_srcDlg->m_rectPlot.Width();
			}

			rect_erase.left = erase_from_pixel;
				
			rect_erase.right = erase_to_pixel + 2;
				
			dc.FillSolidRect( rect_erase, RGB(0, 0, 0) );
		}
	}

	double d_current_pix;
	
	int old_x_pix;
	
	while(iCount >= p_srcDlg->m_iNumberOfChannels)
	{
		int i_no_data = iCount;

		if(i_no_data > MAX_DIGITAL_VALUES)
		{
			i_no_data = MAX_DIGITAL_VALUES;
		}
		
		int i_frames = i_no_data / p_srcDlg->m_iNumberOfChannels;

		int i_count = i_frames * p_srcDlg->m_iNumberOfChannels;

		int i_me_error;
		
		i_me_error = meIOStreamRead(p_srcDlg->m_iDevice,				// Device index
									p_srcDlg->m_iSubdevice,				// Subdevice index, 
									ME_READ_MODE_BLOCKING,				// Read mode 
									&arriMultiplexedDigitalData[0],		// Acquired data values returned in this buffer
									&i_count,							// Size of buffer in data values - Number of data values returned here
									ME_IO_STREAM_READ_NO_FLAGS		);	// No flags

		if(i_me_error != ME_ERRNO_SUCCESS)
		{
			return(-1);;
		}

		i_frames = i_count / p_srcDlg->m_iNumberOfChannels;

		for(int index_channel = 0; index_channel < MAX_CHANNELS; index_channel++)
		{
			if(p_srcDlg->m_arrAIChannels[index_channel].m_bEnabled)
			{
				old_x_pix = p_srcDlg->m_iXLastPixel;
				
				d_current_pix = p_srcDlg->m_dXLastPixel;
				
				CPen pen_draw( PS_SOLID, 0, p_srcDlg->m_crChannelColors[index_channel] );
				
				CPen* p_old_draw_pen =  (CPen*)dc.SelectObject(&pen_draw);
		
				int i_chan_buffer_count = i_frames;
				
				i_me_error = meUtilityExtractValues(p_srcDlg->m_arrAIChannels[index_channel].m_iChannelIndex,
													&arriMultiplexedDigitalData[0],
													i_count,
													&p_srcDlg->m_arrStreamConfig[0],
													p_srcDlg->m_iNumberOfChannels,
													&arriChannelDigitalData[0],
													&i_chan_buffer_count										);

				int* p_i_data = &arriChannelDigitalData[0];
		
				for(int index_frame = 0; index_frame < i_chan_buffer_count; index_frame++)
				{
					int x_pix = (int)d_current_pix;
						
					double d_volt;

					i_me_error =  meUtilityDigitalToPhysical(	p_srcDlg->m_arrAIChannelRange[index_channel].m_dMin,		// Min physical value
																p_srcDlg->m_arrAIChannelRange[index_channel].m_dMax,		// Max physical value
																p_srcDlg->m_arrAIChannelRange[index_channel].m_iMaxData,	// Maximum digital value
																*p_i_data,													// Digital value to convert
																ME_MODULE_TYPE_MULTISIG_NONE,								// Module type - not used
																0.0,														// Reference value - not used
																&d_volt													);	// Converted physical value returned here

					int y_pix = (int)( d_volt * p_srcDlg->m_dYFactor[index_channel] + p_srcDlg->m_dYConstant[index_channel] );

					if( (index_frame == 0)&&(!p_srcDlg->m_bFirstDraw) )
					{
						dc.MoveTo(old_x_pix, p_srcDlg->m_iYLastPixel[index_channel] );
					}

					if(!p_srcDlg->m_bFirstDraw)
					{
						if( (x_pix != old_x_pix)||( y_pix != p_srcDlg->m_iYLastPixel[index_channel] ) )
						{
							dc.LineTo(x_pix, y_pix);
							
							old_x_pix = x_pix;
							
							p_srcDlg->m_iYLastPixel[index_channel] = y_pix;
						}
					}
					else
					{
						dc.MoveTo(x_pix, y_pix);
						
						old_x_pix = x_pix;
						
						p_srcDlg->m_iYLastPixel[index_channel] = y_pix;

						p_srcDlg->m_bFirstDraw = FALSE;
					}

					++p_i_data;
					
					d_current_pix+= p_srcDlg->m_dXIncrement;

					if( (int)d_current_pix > p_srcDlg->m_rectPlot.right )
					{
						d_current_pix-= p_srcDlg->m_rectPlot.Width();

						old_x_pix-= p_srcDlg->m_rectPlot.Width();

						dc.MoveTo(old_x_pix, p_srcDlg->m_iYLastPixel[index_channel] );
					}
				}

				dc.SelectObject(p_old_draw_pen);
			}
		}

		p_srcDlg->m_dXLastPixel = d_current_pix;

		p_srcDlg->m_iXLastPixel = old_x_pix;
		
		p_srcDlg->m_bFirstDraw = false;

		iCount-= i_frames * p_srcDlg->m_iNumberOfChannels;
	}
		
	dc.SelectStockObject(WHITE_PEN);

	dc.MoveTo(p_srcDlg->m_iXLastPixel + 1, p_srcDlg->m_rectPlot.top);
	dc.LineTo(p_srcDlg->m_iXLastPixel + 1, p_srcDlg->m_rectPlot.bottom);

	dc.SelectObject(p_old_pen);
	
	return(ME_ERRNO_SUCCESS);
}

// CTestDialog_StreamRead_CallbackDlg message handlers

BOOL CTestDialog_StreamRead_CallbackDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	int i_me_error;

	// Enable the default Proc

	meErrorSetDefaultProc(ME_SWITCH_ENABLE);

	// Display library version in title

	int i_version_library;
	
	i_me_error = meQueryVersionLibrary(&i_version_library);

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		EndDialog(IDCANCEL);

		return(FALSE);
	}

	i_me_error = meOpen(0);

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		EndDialog(IDCANCEL);

		return(FALSE);
	}

	// Display main driver version in title

	int i_version_main_driver;

	i_me_error = meQueryVersionMainDriver(&i_version_main_driver);

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		EndDialog(IDCANCEL);

		return(FALSE);
	}

	char sz_buffer[256];

	sprintf(&sz_buffer[0], "ME-IDS AI Streaming  -  Library Version: %d.%d.%d.%d  Main Driver Version:  %d.%d.%d.%d", 
							(i_version_library >> 24) & 0x000000FF, (i_version_library >> 16) & 0x000000FF, (i_version_library >> 8) & 0x000000FF, i_version_library & 0x000000FF,
							 (i_version_main_driver >> 24) & 0x000000FF, (i_version_main_driver >> 16) & 0x000000FF, (i_version_main_driver >> 8) & 0x000000FF, i_version_main_driver & 0x000000FF );
	
	SetWindowText(&sz_buffer[0]);
	
	// Query number of devices

	int i_number_of_devices;
	
	i_me_error = meQueryNumberDevices(&i_number_of_devices);

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		EndDialog(IDCANCEL);

		return(FALSE);
	}

	if(i_number_of_devices == 0)
	{
		AfxMessageBox("No ME-IDS devices found in System", MB_OK | MB_ICONEXCLAMATION | MB_SETFOREGROUND);

		EndDialog(IDCANCEL);

		return(FALSE);
	} 

	// Build a list of the AI-Streaming sundevices in the system

	m_iNumberOfAIStreamingSubdevices = 0;

	for(int index_device = 0; index_device < i_number_of_devices; index_device++)
	{
		int i_vendor_id;
		int i_device_id;
		int i_serial_no;
		int i_bus_type;
		int i_bus_no;
		int i_dev_no;
		int i_func_no;
		int i_plugged;
		
		i_me_error = meQueryInfoDevice(	index_device,				// Device index
										&i_vendor_id,				// Vendor ID returned here - not required				
										&i_device_id,				// Device ID returned here - not required
										&i_serial_no,				// Serial number returned here - not required
										&i_bus_type,				// Bus type returned here - not required
										&i_bus_no,					// Bus number returned here - not required
										&i_dev_no,					// Bus device number returned here - not required
										&i_func_no,					// Bus function number returned here - not required
										&i_plugged				);	// Plugged status returned here

		if(i_plugged != ME_PLUGGED_IN)
		{
			continue;
		}

		int i_number_of_subdevices;

		meQueryNumberSubdevices(index_device,				// Device index
								&i_number_of_subdevices);	// Number of sub-devices returned here

		int index_subdevice = 0;

		while(index_subdevice < i_number_of_subdevices) 
		{
			int i_stream_read_subdevice;
			
			i_me_error = meQuerySubdeviceByType(index_device,					// Device index
												index_subdevice,				// Begin search at this sub-device 
												ME_TYPE_AI,						// Type of sub-device to search for
												ME_SUBTYPE_STREAMING,			// Sub-type of sub-device to search for
												&i_stream_read_subdevice	);	// sub-device index returned here

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				break;
			}
			
			m_arrAIStreamingSubdevices[m_iNumberOfAIStreamingSubdevices].m_iDeviceNumber = index_device;
			
			m_arrAIStreamingSubdevices[m_iNumberOfAIStreamingSubdevices].m_iSubdeviceNumber = i_stream_read_subdevice;

			if(++m_iNumberOfAIStreamingSubdevices >= MAX_STREAMING_SUBDEVICES)
			{
				break;
			}
			
			index_subdevice = i_stream_read_subdevice + 1;
		}

		if(m_iNumberOfAIStreamingSubdevices >= MAX_STREAMING_SUBDEVICES)
		{
			break;
		}
	}

	if(m_iNumberOfAIStreamingSubdevices == 0)
	{
		AfxMessageBox("No ME-IDS AI streaming sub-devices found in System", MB_OK | MB_ICONEXCLAMATION | MB_SETFOREGROUND);

		EndDialog(IDCANCEL);

		return(FALSE);
	} 

	CComboBox* p_ai_streaming_subdevice_combo = (CComboBox*)GetDlgItem(IDC_AI_STREAMING_SUBDEVICE_COMBO);

	for(int index_subdevice = 0; index_subdevice < m_iNumberOfAIStreamingSubdevices; index_subdevice++)
	{
		sprintf(	&sz_buffer[0], 
					"Device: %2d - Sub-device: %2d", 
					m_arrAIStreamingSubdevices[index_subdevice].m_iDeviceNumber, 
					m_arrAIStreamingSubdevices[index_subdevice].m_iSubdeviceNumber);

		p_ai_streaming_subdevice_combo->AddString(&sz_buffer[0]);
	}

	p_ai_streaming_subdevice_combo->SetCurSel(0);

	SetAIStreamingSubdevice(0);

	GetDlgItem(IDC_PLOT)->GetClientRect(m_rectPlot);
	
	GetDlgItem(IDC_PLOT)->ClientToScreen(m_rectPlot);
	
	ScreenToClient(m_rectPlot);
	
	m_rectPlot.DeflateRect(1, 1);

	for(int index_channel = 0; index_channel < MAX_CHANNELS; index_channel++)
	{
		m_arrAIChannels[index_channel].m_bEnabled = true;

		m_arrAIChannels[index_channel].m_iChannelIndex = index_channel;

		m_arrAIChannels[index_channel].m_iRangeIndex = 0;
	}

	m_crChannelColors[0]	= RGB(0xFF, 0x00, 0x00);
	m_crChannelColors[1]	= RGB(0x00, 0xFF, 0x00);
	m_crChannelColors[2]	= RGB(0x00, 0x00, 0xFF);
	m_crChannelColors[3]	= RGB(0xFF, 0xFF, 0x00);

	m_dWindowWidthSec		= 4.0;

	m_dWindowMinVolt		= -10.0;

	m_dWindowMaxVolt		= +10.0;

	m_dAchievedFreq			= m_dScanFrequency;

	m_dXIncrement			= 1.0;

	m_dYConstant[0]			= 0.0;
	m_dYConstant[1]			= 0.0;
	m_dYConstant[2]			= 0.0;
	m_dYConstant[3]			= 0.0;

	m_dYFactor[0]			= 1.0;
	m_dYFactor[1]			= 1.0;
	m_dYFactor[2]			= 1.0;
	m_dYFactor[3]			= 1.0;

	m_bFirstDraw			= true;
	
	m_dXLastPixel			= 0.0;
	
	m_iXLastPixel			= 0;
	
	m_iYLastPixel[0] 		= 0;
	m_iYLastPixel[1] 		= 0;
	m_iYLastPixel[2] 		= 0;
	m_iYLastPixel[3] 		= 0;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestDialog_StreamRead_CallbackDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestDialog_StreamRead_CallbackDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();

		CClientDC dc(this);

		dc.FillSolidRect( m_rectPlot, RGB(0, 0, 0) );	
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestDialog_StreamRead_CallbackDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CTestDialog_StreamRead_CallbackDlg::OnBnClickedStart()
{
	// TODO: Add your control notification handler code here

	CDataExchange dx(this, TRUE);
	
	DoDataExchange(&dx);

	m_arrAIChannels[0].m_bEnabled = m_bEnableChannel1;

	m_arrAIChannels[1].m_bEnabled = m_bEnableChannel2;

	m_arrAIChannels[2].m_bEnabled = m_bEnableChannel3;

	m_arrAIChannels[3].m_bEnabled = m_bEnableChannel4;

	CComboBox* p_ai_streaming_subdevice_combo = (CComboBox*)GetDlgItem(IDC_AI_STREAMING_SUBDEVICE_COMBO);

	SetAIStreamingSubdevice( p_ai_streaming_subdevice_combo->GetCurSel() );

	int i_fifo_size = 0;

	int i_caps;

	int i_me_error = meQuerySubdeviceCaps(	m_iDevice,							// Device index
											m_iSubdevice,						// Subdevice index 
											&i_caps				);				// Capabilities returned here

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		return;
	}

	if( ( i_caps & (ME_CAPS_AI_FIFO	| ME_CAPS_AI_FIFO_THRESHOLD) ) == (ME_CAPS_AI_FIFO	| ME_CAPS_AI_FIFO_THRESHOLD) )
	{
		i_me_error = meQuerySubdeviceCapsArgs(	m_iDevice,							// Device index
												m_iSubdevice,						// Subdevice index 
												ME_CAP_AI_FIFO_SIZE,				// Capability
												&i_fifo_size,						// Pointer to argument list
												1					);				// Number of arguments expected

		if(i_me_error != ME_ERRNO_SUCCESS)
		{
			return;
		}
	}

	int i_acq_ticks_low = 0;
	int i_acq_ticks_high = 0;

	double d_time = 0.0;

	i_me_error = meIOStreamTimeToTicks(	m_iDevice,							// Device index
										m_iSubdevice,						// Subdevice index 
										ME_TIMER_ACQ_START,					// Timer used 
										&d_time,							// Required time seconds, Achieved time returned here	 
										&i_acq_ticks_low,					// Lower 32 bits of the corresponding tick value returned here
										&i_acq_ticks_high,					// Upper 32 bits of the corresponding tick value returned here
										ME_IO_FREQUENCY_TO_TICKS_NO_FLAGS); // No flags

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		return;
	}

	int i_scan_ticks_low = 0;
	int i_scan_ticks_high = 0;

	m_dAchievedFreq = m_dScanFrequency;
	
	i_me_error = meIOStreamFrequencyToTicks(m_iDevice,							// Device index
											m_iSubdevice,						// Subdevice indexe, 
											ME_TIMER_SCAN_START,				// Timer used 
											&m_dAchievedFreq,					// Required frequency Hz, Achieved frequency returned here	 
											&i_scan_ticks_low,					// Lower 32 bits of the corresponding tick value returned here
											&i_scan_ticks_high,					// Upper 32 bits of the corresponding tick value returned here
											ME_IO_FREQUENCY_TO_TICKS_NO_FLAGS); // No flags

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		return;
	}

	int i_conv_ticks_low = 0;
	int i_conv_ticks_high = 0;

	d_time = 0.0;

	i_me_error = meIOStreamTimeToTicks(	m_iDevice,							// Device index
										m_iSubdevice,						// Subdevice indexe, 
										ME_TIMER_CONV_START,				// Timer used 
										&d_time,							// Required time seconds, Achieved time returned here	 
										&i_conv_ticks_low,					// Lower 32 bits of the corresponding tick value returned here
										&i_conv_ticks_high,					// Upper 32 bits of the corresponding tick value returned here
										ME_IO_FREQUENCY_TO_TICKS_NO_FLAGS); // No flags

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		return;
	}

	m_dXIncrement = (double)m_rectPlot.Width() / (m_dAchievedFreq * m_dWindowWidthSec);
	
	m_dXLastPixel = (double)m_rectPlot.left;
	
	m_iXLastPixel = m_rectPlot.left;
	
	for(int index_channel = 0; index_channel < MAX_CHANNELS; index_channel++)
	{
		if(m_arrAIChannels[index_channel].m_bEnabled)
		{
			m_iYLastPixel[index_channel] = -1;

			i_me_error = meQueryRangeInfo(	m_iDevice,											// Device index
											m_iSubdevice,										// Subdevice index 
											m_arrAIChannels[index_channel].m_iRangeIndex,		// Range index
											NULL,												// Unit returned here - not require
											&m_arrAIChannelRange[index_channel].m_dMin,			// Physical minimum returned here
											&m_arrAIChannelRange[index_channel].m_dMax,			// Physical maximum returned here
											&m_arrAIChannelRange[index_channel].m_iMaxData	);	// Digital maximum value returned here

			if(i_me_error != ME_ERRNO_SUCCESS)
			{
				return;
			}

			m_dYFactor[index_channel] = (double)m_rectPlot.Height() / (m_dWindowMinVolt - m_dWindowMaxVolt);

			m_dYConstant[index_channel] = (double)m_rectPlot.bottom - m_dYFactor[index_channel] * m_dWindowMinVolt;
		}
	}

	m_iNumberOfChannels = 0;
	
	m_arrStreamConfig[MAX_CHANNELS];

	for(int index_channel = 0; index_channel < MAX_CHANNELS; index_channel++)
	{
		if(m_arrAIChannels[index_channel].m_bEnabled)
		{
			m_arrStreamConfig[m_iNumberOfChannels].iChannel = m_arrAIChannels[index_channel].m_iChannelIndex;

			m_arrStreamConfig[m_iNumberOfChannels].iStreamConfig = m_arrAIChannels[index_channel].m_iRangeIndex;

			m_arrStreamConfig[m_iNumberOfChannels].iRef = ME_REF_AI_GROUND;

			m_arrStreamConfig[m_iNumberOfChannels].iFlags = ME_IO_STREAM_CONFIG_TYPE_NO_FLAGS;

			++m_iNumberOfChannels;
		}
	}

	meIOStreamTrigger_t stream_trigger;

	memset( &stream_trigger, 0, sizeof(meIOStreamTrigger_t) );

	stream_trigger.iAcqStartTrigType = ME_TRIG_TYPE_SW;
	
	// int iAcqStartTrigEdge;
	stream_trigger.iAcqStartTrigChan = ME_TRIG_CHAN_DEFAULT;
	stream_trigger.iAcqStartTicksLow = i_acq_ticks_low;
	stream_trigger.iAcqStartTicksHigh = i_acq_ticks_high;
	// int iAcqStartArgs[10];
	stream_trigger.iScanStartTrigType = ME_TRIG_TYPE_TIMER;
	stream_trigger.iScanStartTicksLow = i_scan_ticks_low;
	stream_trigger.iScanStartTicksHigh = i_scan_ticks_high;
	//int iScanStartArgs[10];
	stream_trigger.iConvStartTrigType = ME_TRIG_TYPE_TIMER;
	stream_trigger.iConvStartTicksLow = i_conv_ticks_low;
	stream_trigger.iConvStartTicksHigh = i_conv_ticks_high;
	//int iConvStartArgs[10];
	// int iScanStopTrigType;
	// int iScanStopCount;
	// int iScanStopArgs[10];
	// int iAcqStopTrigType;
	// int iAcqStopCount;
	// int iAcqStopArgs[10];
	stream_trigger.iFlags = ME_IO_STREAM_TRIGGER_TYPE_NO_FLAGS;

	i_me_error = meIOStreamConfig(	m_iDevice,							// Device index
									m_iSubdevice,						// Subdevice index, 
 									&m_arrStreamConfig[0],				// Pointer to an array of meIOStreamConfig_t structures
									m_iNumberOfChannels,				// Number of elements in the stream config array above
									&stream_trigger,					// Pointer to an meIOStreamTrigger_t structure
									m_iSampleCounter,					// FIFO IRQ threshold
									ME_IO_STREAM_CONFIG_NO_FLAGS	);	// No flags

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		return;
	}

	p_ai_streaming_subdevice_combo->EnableWindow(FALSE);

	CClientDC dc(this);

	m_bFirstDraw = true;
	
	dc.FillSolidRect( m_rectPlot, RGB(0, 0, 0) );	

	meIOStreamStart_t arr_stream_start[1];

	arr_stream_start[0].iDevice = m_iDevice;
	arr_stream_start[0].iSubdevice = m_iSubdevice;
	arr_stream_start[0].iStartMode = ME_START_MODE_BLOCKING;
	arr_stream_start[0].iTimeOut = 5;
	arr_stream_start[0].iFlags = ME_IO_STREAM_START_TYPE_NO_FLAGS;
	arr_stream_start[0].iErrno = 0;
	
	i_me_error = meIOStreamStart(	&arr_stream_start[0],			// Pointer to an array of meIOStreamStart_t structures 
									1,								// Number of elements in the stream start array above
									ME_IO_STREAM_START_NO_FLAGS	);	// No flags
}

void CTestDialog_StreamRead_CallbackDlg::OnBnClickedStop()
{
	// TODO: Add your control notification handler code here

	meIOStreamStop_t arr_stream_stop[1];

	arr_stream_stop[0].iDevice = m_iDevice;
	arr_stream_stop[0].iSubdevice = m_iSubdevice;
	arr_stream_stop[0].iStopMode = ME_STOP_MODE_IMMEDIATE;
	arr_stream_stop[0].iFlags = ME_IO_STREAM_STOP_TYPE_NO_FLAGS;
	arr_stream_stop[0].iErrno = 0;

	int i_me_error = meIOStreamStop(&arr_stream_stop[0],			// Pointer to an array of meIOStreamStop_t structures  
									1,								// Number of elements in the stream stop array above
									ME_IO_STREAM_STOP_NO_FLAGS);	// No flags


	CComboBox* p_ai_streaming_subdevice_combo = (CComboBox*)GetDlgItem(IDC_AI_STREAMING_SUBDEVICE_COMBO);

	p_ai_streaming_subdevice_combo->EnableWindow(TRUE);
}


void CTestDialog_StreamRead_CallbackDlg::OnCancel()
{
	// TODO: Add your specialized code here and/or call the base class

	OnBnClickedStop();

	CDialog::OnCancel();
}
